/* Generated automatically with "cito". Do not edit. */
#ifndef _FAIL_H_
#define _FAIL_H_
typedef int cibool;
#ifndef TRUE
#define TRUE 1
#endif
#ifndef FALSE
#define FALSE 0
#endif
#ifdef __cplusplus
extern "C" {
#endif
typedef struct FAIL FAIL;

FAIL *FAIL_New(void);
void FAIL_Delete(FAIL *self);

/**
 * Short license notice.
 * Display after the credits.
 */
#define FAIL_COPYRIGHT  "This program is free software; you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published\nby the Free Software Foundation; either version 2 of the License,\nor (at your option) any later version."

/**
 * Short credits for FAIL.
 */
#define FAIL_CREDITS  "First Atari Image Library (C) 2009-2013 Piotr Fusik and Adrian Matoga\n"

/**
 * Decodes Atari picture file to an RGB bitmap.
 * Returns <code>true</code> on success.
 * @param filename Name of the file to decode. Only the extension is processed, for format recognition.
 * @param content File contents.
 * @param contentLength File length.
 */
cibool FAIL_Decode(FAIL *self, const char *filename, unsigned char const *content, int contentLength);

/**
 * Returns number of unique colors in the decoded picture.
 */
int FAIL_GetColors(FAIL *self);

/**
 * Returns the number of alternating frames the pictures is composed of.
 * 
 * <ul>
 * <li>1 means the picture doesn't flicker.</li>
 * <li>2 means the picture is displayed by quickly alternating two sub-pictures.</li>
 * <li>3 means the picture is displayed by alternating three sub-pictures.</li>
 * </ul>
 * 
 */
int FAIL_GetFrames(FAIL const *self);

/**
 * Returns decoded image height.
 */
int FAIL_GetHeight(FAIL const *self);

/**
 * Returns original height of the decoded image (informational).
 */
int FAIL_GetOriginalHeight(FAIL const *self);

/**
 * Returns original width of the decoded image (informational).
 */
int FAIL_GetOriginalWidth(FAIL const *self);

/**
 * Returns pixels of the decoded image, top-down, left-to-right.
 * Each pixel is a 24-bit integer 0xRRGGBB.
 */
int const *FAIL_GetPixels(FAIL const *self);

/**
 * Returns the computer family of the decoded file format.
 */
const char *FAIL_GetPlatform(FAIL const *self);

/**
 * Returns decoded image width.
 */
int FAIL_GetWidth(FAIL const *self);

/**
 * Checks whether the filename extension is supported by FAIL.
 * <code>true</code> doesn't necessarily mean that the file contents is valid for FAIL.
 * This function is meant to avoid reading files which are known to be
 * not supported (another criterium is the maximum file size, <code>MaxContentLength</code>).
 */
cibool FAIL_IsOurFile(const char *filename);

/**
 * Maximum length of a supported input file.
 * You may assume that files longer than this are not supported by FAIL.
 */
#define FAIL_MAX_CONTENT_LENGTH  350000

/**
 * Maximum height of a decoded image.
 */
#define FAIL_MAX_HEIGHT  560

/**
 * Maximum number of pixels in a decoded image.
 */
#define FAIL_MAX_PIXELS_LENGTH  358400

/**
 * Maximum length of a string returned by <code>GetPlatform()</code>.
 */
#define FAIL_MAX_PLATFORM_LENGTH  15

/**
 * Maximum width of a decoded image.
 */
#define FAIL_MAX_WIDTH  640

/**
 * Sets Atari 8-bit palette from a 768-byte array (256 times RGB).
 */
void FAIL_SetAtari8Palette(FAIL *self, unsigned char const *content);

/**
 * Converts the decoded picture to palette-indexed.
 * Returns palette of 256 0xRRGGBB entries.
 * Call <code>GetColors()</code> for the actual number of colors.
 * Returns <code>null</code> if conversion fails,
 * because there are more than 256 colors.
 * @param indexes Out: palette-indexed picture.
 */
int const *FAIL_ToPalette(FAIL *self, unsigned char *indexes);

/**
 * FAIL version as a string.
 */
#define FAIL_VERSION  "2.0.1"

/**
 * FAIL version - major part.
 */
#define FAIL_VERSION_MAJOR  2

/**
 * FAIL version - micro part.
 */
#define FAIL_VERSION_MICRO  1

/**
 * FAIL version - minor part.
 */
#define FAIL_VERSION_MINOR  0

/**
 * Years FAIL was created in.
 */
#define FAIL_YEARS  "2009-2013"

#ifdef __cplusplus
}
#endif
#endif
