/* Generated automatically with "cito". Do not edit. */
#include <stdlib.h>
#include <string.h>
#include "fail.h"
typedef struct A4rStream A4rStream;
typedef struct BitStream BitStream;
typedef struct BlazingPaddlesBoundingBox BlazingPaddlesBoundingBox;
typedef struct CaStream CaStream;
typedef struct CciStream CciStream;

/**
 * Platform and pixel ratio.
 */
typedef enum {
	FAILResolution_XE1X1,
	FAILResolution_XE2X1,
	FAILResolution_XE4X1,
	FAILResolution_XE2X2,
	FAILResolution_XE4X2,
	FAILResolution_ST1X1,
	FAILResolution_ST1X2,
	FAILResolution_STE1X1,
	FAILResolution_STE1X2,
	FAILResolution_FALCON1X1,
	FAILResolution_PORTFOLIO1X1,
	FAILResolution_AMIGA1X1
}
FAILResolution;
typedef struct FanoTree FanoTree;
typedef struct HpmStream HpmStream;
typedef struct IcnParser IcnParser;
typedef struct KoalaStream KoalaStream;
typedef struct PacStream PacStream;
typedef struct PackBitsStream PackBitsStream;
typedef struct PcsStream PcsStream;
typedef struct PgcStream PgcStream;
typedef struct RgbStream RgbStream;
typedef struct RleStream RleStream;
typedef struct SpcStream SpcStream;
typedef struct SpsStream SpsStream;
typedef struct TnyPcsStream TnyPcsStream;
typedef struct TnyStream TnyStream;
typedef struct VdatStream VdatStream;
typedef struct XlpStream XlpStream;

struct A4rStream {
	int contentLength;
	int contentOffset;
	int innerFlags;
	int outerFlags;
	int unpackedOffset;
	unsigned char const *content;
	unsigned char unpacked[11248];
};
static void A4rStream_Construct(A4rStream *self);
static cibool A4rStream_CopyBlock(A4rStream *self, int distance, int length);
static int A4rStream_ReadByte(A4rStream *self);
static int A4rStream_ReadFlag(A4rStream *self);
static cibool A4rStream_StoreByte(A4rStream *self, int value);
static cibool A4rStream_UnpackA4r(A4rStream *self);

struct BitStream {
	int bits;
	int contentLength;
	int contentOffset;
	unsigned char const *content;
};
static void BitStream_Construct(BitStream *self);
static int BitStream_ReadBit(BitStream *self);
static int BitStream_ReadBits(BitStream *self, int count);

struct BlazingPaddlesBoundingBox {
	int bottom;
	int left;
	int right;
	int top;
};
static cibool BlazingPaddlesBoundingBox_Calculate(BlazingPaddlesBoundingBox *self, unsigned char const *content, int contentLength, int index, int startAddress);

typedef struct {
	cibool (*readCommand)(RleStream *self);
	int (*readValue)(RleStream *self);
}
RleStreamVtbl;
struct RleStream {
	BitStream base;
	const RleStreamVtbl *vtbl;
	/**
	 * Block length.
	 */
	int repeatCount;
	/**
	 * Value for an RLE block, -1 for a block of literals.
	 */
	int repeatValue;
};
static void RleStream_Construct(RleStream *self, const RleStreamVtbl *vtbl);
static int RleStream_ReadByte(RleStream *self);
static int RleStream_ReadRle(RleStream *self);
static int RleStream_ReadValue(RleStream *self);
static cibool RleStream_Unpack(RleStream *self, unsigned char *unpacked, int unpackedOffset, int unpackedStride, int unpackedCount);

struct CaStream {
	RleStream base;
	int defaultValue;
	int escapeByte;
};
static void CaStream_Construct(CaStream *self, const RleStreamVtbl *vtbl);
static cibool CaStream_ReadCommand(CaStream *self);
static cibool CaStream_UnpackCa(unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedOffset);
static cibool CaStream_UnpackDel(unsigned char const *content, int contentLength, unsigned char *unpacked, int blocks);
static const RleStreamVtbl CiVtbl_CaStream = {
	(cibool (*)(RleStream *self)) CaStream_ReadCommand,
	RleStream_ReadValue
};

struct CciStream {
	RleStream base;
};
static void CciStream_Construct(CciStream *self, const RleStreamVtbl *vtbl);
static cibool CciStream_ReadCommand(CciStream *self);
static cibool CciStream_UnpackGr15(CciStream *self, unsigned char *unpacked, int unpackedOffset);
static const RleStreamVtbl CiVtbl_CciStream = {
	(cibool (*)(RleStream *self)) CciStream_ReadCommand,
	RleStream_ReadValue
};

struct FAIL {
	int colors;
	/**
	 * Number of frames (normally 1; 2 or 3 for flickering pictures).
	 */
	int frames;
	int gtiaLeftSkip;
	/**
	 * Decoded image height.
	 */
	int height;
	/**
	 * Platform and pixel ratio.
	 */
	FAILResolution resolution;
	/**
	 * Decoded image width.
	 */
	int width;
	unsigned char gtiaColors[16];
	/**
	 * Atari ST/Falcon/Portfolio palette.
	 * Unlike Atari 8-bit, this palette is always decoded from the image file.
	 */
	int atari16Palette[256];
	int atari8Palette[256];
	int palette[256];
	/**
	 * Decoded image pixels as 0xRRGGBB.
	 */
	int pixels[358400];
};
static void FAIL_Construct(FAIL *self);
static cibool FAIL_ApplyAtari8Palette(FAIL *self, unsigned char const *frame);
static cibool FAIL_ApplyAtari8PaletteBlend(FAIL *self, unsigned char const *frame1, unsigned char const *frame2);
static cibool FAIL_ApplyAtari8PaletteBlend3(FAIL *self, unsigned char const *frame1, unsigned char const *frame2, unsigned char const *frame3);
static void FAIL_CalculatePalette(FAIL *self, int *palette, int paletteOffset, int paletteLength);
static cibool FAIL_Decode256(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_Decode4mi(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_Decode4pl(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_Decode4pm(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeA4r(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAcs(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAgp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAll(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAp3(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeApc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeApl(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeApp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeArtDirector(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAsciiArtEditor(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeAt800Missiles(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset);
static void FAIL_DecodeAt800Players(FAIL const *self, unsigned char const *content, unsigned char *frame);
static cibool FAIL_DecodeAtari8Artist(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeAtari8Font(FAIL *self, unsigned char const *characters, unsigned char const *font, int fontOffset);
static void FAIL_DecodeAtari8Gr0(FAIL const *self, unsigned char const *characters, int charactersStride, unsigned char const *font, int fontOffset, unsigned char *frame);
static void FAIL_DecodeAtari8Gr10(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int frameStride, int height);
static void FAIL_DecodeAtari8Gr11(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int frameStride, int height);
static void FAIL_DecodeAtari8Gr11PalBlend(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int y);
static void FAIL_DecodeAtari8Gr12(FAIL const *self, unsigned char const *content, int charactersOffset, int fontOffset, unsigned char *frame);
static void FAIL_DecodeAtari8Gr12Line(FAIL const *self, unsigned char const *characters, int charactersOffset, unsigned char const *font, int fontOffset, unsigned char *frame, int frameOffset);
static void FAIL_DecodeAtari8Gr15(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int frameOffset, int frameStride, int height);
static void FAIL_DecodeAtari8Gr7(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int height);
static void FAIL_DecodeAtari8Gr8(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame);
static void FAIL_DecodeAtari8Gr9(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int frameOffset, int frameStride, int width, int height);
static cibool FAIL_DecodeAtari8Icn(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeAtari8Player(FAIL const *self, unsigned char const *content, int contentOffset, int color, unsigned char *frame, int frameOffset, int height);
static cibool FAIL_DecodeAtari8Spc(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeBitplanes(FAIL *self, unsigned char const *content, int contentOffset, int bitplanes, int pixelsOffset, int pixelsCount);
static cibool FAIL_DecodeBkg(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeBlackAndWhite(FAIL *self, unsigned char const *content, int contentOffset, int width, int height, FAILResolution resolution);
static cibool FAIL_DecodeBlazingPaddlesVectors(FAIL *self, unsigned char const *content, int contentLength, int startAddress);
static cibool FAIL_DecodeBru(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeCa(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeCci(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeChr(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeCin(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeCpr(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeCpt(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDel(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDgc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDgu(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDin(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDlm(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDoo(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDph(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeDrg(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeFalconPalette320(FAIL *self, unsigned char const *content, int bitplanesOffset, int paletteOffset, int height);
static cibool FAIL_DecodeFalconTrueColor(FAIL *self, unsigned char const *content, int contentLength, int contentOffset, int width, int height);
static cibool FAIL_DecodeFalconTrueColorVariable(FAIL *self, unsigned char const *content, int contentLength, int widthOffset, int dataOffset);
static cibool FAIL_DecodeFnt(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeFtc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeFwa(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeG09(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeG10(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeG11(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeGfb(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeGhg(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeGod(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeGr15Blend(FAIL *self, unsigned char const *content, int bitmapOffset, int colorsOffset, int height);
static cibool FAIL_DecodeGr7(FAIL *self, unsigned char const *content, int contentOffset, int contentSize);
static cibool FAIL_DecodeGr8(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeGr9(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeHam(FAIL *self, unsigned char const *unpacked, int width, int height, int bitplanes);
static cibool FAIL_DecodeHip(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeHpm(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeHr(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeHr2(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeIce(FAIL *self, unsigned char const *content, int contentOffset, unsigned char *frame1, unsigned char *screen2);
static cibool FAIL_DecodeIff(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeIffUnpacked(FAIL *self, unsigned char *unpacked, int width, int height, int bitplanes, int colors, int camg);
static cibool FAIL_DecodeIge(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeImn(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeInp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeInt(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeIp2(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeIpc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeIr2(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeIrg(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeIst(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeJgp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMax(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMbg(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMch(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMcp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMcs(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMgp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMic(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeMis(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeNeo(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeNlq(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePac(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePcs(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodePcsScreen(FAIL *self, unsigned char const *unpacked, int pixelsOffset);
static cibool FAIL_DecodePgc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePgf(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePi(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePi4(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePic(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePla(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodePmd(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeRaw(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeRgb(FAIL *self, unsigned char const *content, int contentLength);
static void FAIL_DecodeRgbScreen(FAIL *self, unsigned char const *screens, int screensOffset, int color, unsigned char *frame);
static cibool FAIL_DecodeRip(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeRm(FAIL *self, unsigned char const *content, int contentLength, int mode, FAILResolution resolution);
static cibool FAIL_DecodeSge(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeShc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeShp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeSps(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeSpu(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeSt(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset, int mode);
static cibool FAIL_DecodeStIcn(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeStLow(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset, int width, int height);
static void FAIL_DecodeStMedium(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset);
static cibool FAIL_DecodeStSpc(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeSxs(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeTip(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeTny(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeTrp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeTru(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeVzi(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeWnd(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DecodeXlp(FAIL *self, unsigned char const *content, int contentLength);
static cibool FAIL_DrawBlazingPaddlesVector(FAIL const *self, unsigned char const *content, int contentLength, unsigned char *frame, int frameOffset, int index, int startAddress);
static void FAIL_DrawSpcBrush(unsigned char *pixels, int x1, int y1, int brush, int pattern);
static void FAIL_DrawSpcChar(unsigned char *pixels, int x1, int y1, int ch);
static void FAIL_DrawSpcLine(unsigned char *pixels, int x1, int y1, int x2, int y2, int color);
static cibool FAIL_FillSpc(unsigned char *pixels, int x, int y, int pattern);
static int FAIL_FindColor(int const *palette, int paletteEnd, int rgb);
static int FAIL_Get32BigEndian(unsigned char const *content, int contentOffset);
static int FAIL_GetAtari8ExecutableOffset(unsigned char const *content, int contentLength);
static int FAIL_GetPackedExt(const char *filename);
static int FAIL_GetStColor(FAIL const *self, unsigned char const *content, int contentOffset);
static cibool FAIL_IsStePalette(unsigned char const *content, int contentOffset, int colors);
static cibool FAIL_IsStringAt(unsigned char const *content, int contentOffset, const char *s);
static int FAIL_ParseAtari8ExecutableHeader(unsigned char const *content, int contentOffset);
static void FAIL_PlotSpcPattern(unsigned char *pixels, int x, int y, int pattern);
static cibool FAIL_SetAtari8RawSize(FAIL *self, unsigned char const *content, int contentLength, FAILResolution resolution);
static void FAIL_SetBakPF012(FAIL *self, unsigned char const *content, int contentOffset, int contentStride);
static void FAIL_SetBakPF0123(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetFalconPalette(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetGr15DefaultColors(FAIL *self);
static void FAIL_SetGtiaColor(FAIL *self, int reg, int value);
static void FAIL_SetGtiaColors(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetPF0123Bak(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetPF0123Even(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetPF012Bak(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetPF21(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetPM123PF0123Bak(FAIL *self, unsigned char const *content, int contentOffset);
static void FAIL_SetSize(FAIL *self, int width, int height, FAILResolution resolution);
static void FAIL_SetSizeStOrFalcon(FAIL *self, int width, int height, int bitplanes);
static void FAIL_SetStPalette(FAIL *self, unsigned char const *content, int contentOffset, int colors);
static int FAIL_ToAtari8Char(int ascii);
static cibool FAIL_UnpackRip(FAIL const *self, unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedLength);
static cibool FAIL_UnpackSpc(RleStream *rle, unsigned char *unpacked);
static const unsigned char CiBinaryResource_atari8_fnt[1024] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 24, 24, 24, 24, 0, 24, 0,
	0, 102, 102, 102, 0, 0, 0, 0, 0, 102, 255, 102, 102, 255, 102, 0,
	24, 62, 96, 60, 6, 124, 24, 0, 0, 102, 108, 24, 48, 102, 70, 0,
	28, 54, 28, 56, 111, 102, 59, 0, 0, 24, 24, 24, 0, 0, 0, 0,
	0, 14, 28, 24, 24, 28, 14, 0, 0, 112, 56, 24, 24, 56, 112, 0,
	0, 102, 60, 255, 60, 102, 0, 0, 0, 24, 24, 126, 24, 24, 0, 0,
	0, 0, 0, 0, 0, 24, 24, 48, 0, 0, 0, 126, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 24, 24, 0, 0, 6, 12, 24, 48, 96, 64, 0,
	0, 60, 102, 110, 118, 102, 60, 0, 0, 24, 56, 24, 24, 24, 126, 0,
	0, 60, 102, 12, 24, 48, 126, 0, 0, 126, 12, 24, 12, 102, 60, 0,
	0, 12, 28, 60, 108, 126, 12, 0, 0, 126, 96, 124, 6, 102, 60, 0,
	0, 60, 96, 124, 102, 102, 60, 0, 0, 126, 6, 12, 24, 48, 48, 0,
	0, 60, 102, 60, 102, 102, 60, 0, 0, 60, 102, 62, 6, 12, 56, 0,
	0, 0, 24, 24, 0, 24, 24, 0, 0, 0, 24, 24, 0, 24, 24, 48,
	6, 12, 24, 48, 24, 12, 6, 0, 0, 0, 126, 0, 0, 126, 0, 0,
	96, 48, 24, 12, 24, 48, 96, 0, 0, 60, 102, 12, 24, 0, 24, 0,
	0, 60, 102, 110, 110, 96, 62, 0, 0, 24, 60, 102, 102, 126, 102, 0,
	0, 124, 102, 124, 102, 102, 124, 0, 0, 60, 102, 96, 96, 102, 60, 0,
	0, 120, 108, 102, 102, 108, 120, 0, 0, 126, 96, 124, 96, 96, 126, 0,
	0, 126, 96, 124, 96, 96, 96, 0, 0, 62, 96, 96, 110, 102, 62, 0,
	0, 102, 102, 126, 102, 102, 102, 0, 0, 126, 24, 24, 24, 24, 126, 0,
	0, 6, 6, 6, 6, 102, 60, 0, 0, 102, 108, 120, 120, 108, 102, 0,
	0, 96, 96, 96, 96, 96, 126, 0, 0, 99, 119, 127, 107, 99, 99, 0,
	0, 102, 118, 126, 126, 110, 102, 0, 0, 60, 102, 102, 102, 102, 60, 0,
	0, 124, 102, 102, 124, 96, 96, 0, 0, 60, 102, 102, 102, 108, 54, 0,
	0, 124, 102, 102, 124, 108, 102, 0, 0, 60, 96, 60, 6, 6, 60, 0,
	0, 126, 24, 24, 24, 24, 24, 0, 0, 102, 102, 102, 102, 102, 126, 0,
	0, 102, 102, 102, 102, 60, 24, 0, 0, 99, 99, 107, 127, 119, 99, 0,
	0, 102, 102, 60, 60, 102, 102, 0, 0, 102, 102, 60, 24, 24, 24, 0,
	0, 126, 12, 24, 48, 96, 126, 0, 0, 30, 24, 24, 24, 24, 30, 0,
	0, 64, 96, 48, 24, 12, 6, 0, 0, 120, 24, 24, 24, 24, 120, 0,
	0, 8, 28, 54, 99, 0, 0, 0, 0, 0, 0, 0, 0, 0, 255, 0,
	0, 54, 127, 127, 62, 28, 8, 0, 24, 24, 24, 31, 31, 24, 24, 24,
	3, 3, 3, 3, 3, 3, 3, 3, 24, 24, 24, 248, 248, 0, 0, 0,
	24, 24, 24, 248, 248, 24, 24, 24, 0, 0, 0, 248, 248, 24, 24, 24,
	3, 7, 14, 28, 56, 112, 224, 192, 192, 224, 112, 56, 28, 14, 7, 3,
	1, 3, 7, 15, 31, 63, 127, 255, 0, 0, 0, 0, 15, 15, 15, 15,
	128, 192, 224, 240, 248, 252, 254, 255, 15, 15, 15, 15, 0, 0, 0, 0,
	240, 240, 240, 240, 0, 0, 0, 0, 255, 255, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 255, 255, 0, 0, 0, 0, 240, 240, 240, 240,
	0, 28, 28, 119, 119, 8, 28, 0, 0, 0, 0, 31, 31, 24, 24, 24,
	0, 0, 0, 255, 255, 0, 0, 0, 24, 24, 24, 255, 255, 24, 24, 24,
	0, 0, 60, 126, 126, 126, 60, 0, 0, 0, 0, 0, 255, 255, 255, 255,
	192, 192, 192, 192, 192, 192, 192, 192, 0, 0, 0, 255, 255, 24, 24, 24,
	24, 24, 24, 255, 255, 0, 0, 0, 240, 240, 240, 240, 240, 240, 240, 240,
	24, 24, 24, 31, 31, 0, 0, 0, 120, 96, 120, 96, 126, 24, 30, 0,
	0, 24, 60, 126, 24, 24, 24, 0, 0, 24, 24, 24, 126, 60, 24, 0,
	0, 24, 48, 126, 48, 24, 0, 0, 0, 24, 12, 126, 12, 24, 0, 0,
	0, 24, 60, 126, 126, 60, 24, 0, 0, 0, 60, 6, 62, 102, 62, 0,
	0, 96, 96, 124, 102, 102, 124, 0, 0, 0, 60, 96, 96, 96, 60, 0,
	0, 6, 6, 62, 102, 102, 62, 0, 0, 0, 60, 102, 126, 96, 60, 0,
	0, 14, 24, 62, 24, 24, 24, 0, 0, 0, 62, 102, 102, 62, 6, 124,
	0, 96, 96, 124, 102, 102, 102, 0, 0, 24, 0, 56, 24, 24, 60, 0,
	0, 6, 0, 6, 6, 6, 6, 60, 0, 96, 96, 108, 120, 108, 102, 0,
	0, 56, 24, 24, 24, 24, 60, 0, 0, 0, 102, 127, 127, 107, 99, 0,
	0, 0, 124, 102, 102, 102, 102, 0, 0, 0, 60, 102, 102, 102, 60, 0,
	0, 0, 124, 102, 102, 124, 96, 96, 0, 0, 62, 102, 102, 62, 6, 6,
	0, 0, 124, 102, 96, 96, 96, 0, 0, 0, 62, 96, 60, 6, 124, 0,
	0, 24, 126, 24, 24, 24, 14, 0, 0, 0, 102, 102, 102, 102, 62, 0,
	0, 0, 102, 102, 102, 60, 24, 0, 0, 0, 99, 107, 127, 62, 54, 0,
	0, 0, 102, 60, 24, 60, 102, 0, 0, 0, 102, 102, 102, 62, 12, 120,
	0, 0, 126, 12, 24, 48, 126, 0, 0, 24, 60, 126, 126, 24, 60, 0,
	24, 24, 24, 24, 24, 24, 24, 24, 0, 126, 120, 124, 110, 102, 6, 0,
	8, 24, 56, 120, 56, 24, 8, 0, 16, 24, 28, 30, 28, 24, 16, 0 };
static const unsigned char CiBinaryResource_jakub_act[768] = { 45, 45, 45, 59, 59, 59, 73, 73, 73, 87, 87, 87, 101, 101, 101, 115,
	115, 115, 129, 129, 129, 143, 143, 143, 157, 157, 157, 171, 171, 171, 185, 185,
	185, 199, 199, 199, 213, 213, 213, 227, 227, 227, 241, 241, 241, 255, 255, 255,
	92, 35, 0, 106, 49, 0, 120, 63, 0, 134, 77, 10, 148, 91, 24, 162,
	105, 38, 176, 119, 52, 190, 133, 66, 204, 147, 80, 218, 161, 94, 232, 175,
	108, 246, 189, 122, 255, 203, 136, 255, 217, 150, 255, 231, 164, 255, 245, 178,
	105, 20, 9, 119, 34, 23, 133, 48, 37, 147, 62, 51, 161, 76, 65, 175,
	90, 79, 189, 104, 93, 203, 118, 107, 217, 132, 121, 231, 146, 135, 245, 160,
	149, 255, 174, 163, 255, 188, 177, 255, 202, 191, 255, 216, 205, 255, 230, 219,
	108, 10, 56, 122, 24, 70, 136, 38, 84, 150, 52, 98, 164, 66, 112, 178,
	80, 126, 192, 94, 140, 206, 108, 154, 220, 122, 168, 234, 136, 182, 248, 150,
	196, 255, 164, 210, 255, 178, 224, 255, 192, 238, 255, 206, 252, 255, 220, 255,
	100, 5, 101, 114, 19, 115, 128, 33, 129, 142, 47, 143, 156, 61, 157, 170,
	75, 171, 184, 89, 185, 198, 103, 199, 212, 117, 213, 226, 131, 227, 240, 145,
	241, 254, 159, 255, 255, 173, 255, 255, 187, 255, 255, 201, 255, 255, 215, 255,
	82, 7, 137, 96, 21, 151, 110, 35, 165, 124, 49, 179, 138, 63, 193, 152,
	77, 207, 166, 91, 221, 180, 105, 235, 194, 119, 249, 208, 133, 255, 222, 147,
	255, 236, 161, 255, 250, 175, 255, 255, 189, 255, 255, 203, 255, 255, 217, 255,
	58, 16, 156, 72, 30, 170, 86, 44, 184, 100, 58, 198, 114, 72, 212, 128,
	86, 226, 142, 100, 240, 156, 114, 254, 170, 128, 255, 184, 142, 255, 198, 156,
	255, 212, 170, 255, 226, 184, 255, 240, 198, 255, 254, 212, 255, 255, 226, 255,
	31, 30, 156, 45, 44, 170, 59, 58, 184, 73, 72, 198, 87, 86, 212, 101,
	100, 226, 115, 114, 240, 129, 128, 254, 143, 142, 255, 157, 156, 255, 171, 170,
	255, 185, 184, 255, 199, 198, 255, 213, 212, 255, 227, 226, 255, 241, 240, 255,
	7, 46, 137, 21, 60, 151, 35, 74, 165, 49, 88, 179, 63, 102, 193, 77,
	116, 207, 91, 130, 221, 105, 144, 235, 119, 158, 249, 133, 172, 255, 147, 186,
	255, 161, 200, 255, 175, 214, 255, 189, 228, 255, 203, 242, 255, 217, 255, 255,
	0, 62, 101, 3, 76, 115, 17, 90, 129, 31, 104, 143, 45, 118, 157, 59,
	132, 171, 73, 146, 185, 87, 160, 199, 101, 174, 213, 115, 188, 227, 129, 202,
	241, 143, 216, 255, 157, 230, 255, 171, 244, 255, 185, 255, 255, 199, 255, 255,
	0, 75, 56, 0, 89, 70, 9, 103, 84, 23, 117, 98, 37, 131, 112, 51,
	145, 126, 65, 159, 140, 79, 173, 154, 93, 187, 168, 107, 201, 182, 121, 215,
	196, 135, 229, 210, 149, 243, 224, 163, 255, 238, 177, 255, 252, 191, 255, 255,
	0, 82, 9, 0, 96, 23, 12, 110, 37, 26, 124, 51, 40, 138, 65, 54,
	152, 79, 68, 166, 93, 82, 180, 107, 96, 194, 121, 110, 208, 135, 124, 222,
	149, 138, 236, 163, 152, 250, 177, 166, 255, 191, 180, 255, 205, 194, 255, 219,
	0, 83, 0, 11, 97, 0, 25, 111, 0, 39, 125, 10, 53, 139, 24, 67,
	153, 38, 81, 167, 52, 95, 181, 66, 109, 195, 80, 123, 209, 94, 137, 223,
	108, 151, 237, 122, 165, 251, 136, 179, 255, 150, 193, 255, 164, 207, 255, 178,
	19, 78, 0, 33, 92, 0, 47, 106, 0, 61, 120, 0, 75, 134, 0, 89,
	148, 11, 103, 162, 25, 117, 176, 39, 131, 190, 53, 145, 204, 67, 159, 218,
	81, 173, 232, 95, 187, 246, 109, 201, 255, 123, 215, 255, 137, 229, 255, 151,
	45, 67, 0, 59, 81, 0, 73, 95, 0, 87, 109, 0, 101, 123, 0, 115,
	137, 1, 129, 151, 15, 143, 165, 29, 157, 179, 43, 171, 193, 57, 185, 207,
	71, 199, 221, 85, 213, 235, 99, 227, 249, 113, 241, 255, 127, 255, 255, 141,
	70, 51, 0, 84, 65, 0, 98, 79, 0, 112, 93, 0, 126, 107, 0, 140,
	121, 11, 154, 135, 25, 168, 149, 39, 182, 163, 53, 196, 177, 67, 210, 191,
	81, 224, 205, 95, 238, 219, 109, 252, 233, 123, 255, 247, 137, 255, 255, 151 };

struct FanoTree {
	/**
	 * Count[n] == number of codes of bit length n.
	 */
	int count[16];
	/**
	 * Values sorted by code length.
	 */
	unsigned char values[256];
};
static void FanoTree_Create(FanoTree *self, unsigned char const *content, int contentOffset, int codeCount);
static int FanoTree_ReadCode(FanoTree const *self, BitStream *bitStream);

struct HpmStream {
	RleStream base;
};
static void HpmStream_Construct(HpmStream *self, const RleStreamVtbl *vtbl);
static cibool HpmStream_ReadCommand(HpmStream *self);
static const RleStreamVtbl CiVtbl_HpmStream = {
	(cibool (*)(RleStream *self)) HpmStream_ReadCommand,
	RleStream_ReadValue
};

struct IcnParser {
	int contentLength;
	int contentOffset;
	unsigned char const *content;
};
static cibool IcnParser_Expect(IcnParser *self, const char *s);
static int IcnParser_ParseDefine(IcnParser *self, const char *s);
static int IcnParser_ParseHex(IcnParser *self);
static cibool IcnParser_SkipWhitespace(IcnParser *self);

struct KoalaStream {
	RleStream base;
};
static void KoalaStream_Construct(KoalaStream *self, const RleStreamVtbl *vtbl);
static cibool KoalaStream_ReadCommand(KoalaStream *self);
static cibool KoalaStream_UnpackKoala(int type, unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedLength);
static cibool KoalaStream_UnpackKoalaWrapped(unsigned char const *content, int contentLength, unsigned char *unpacked, int unpackedLength);
static const RleStreamVtbl CiVtbl_KoalaStream = {
	(cibool (*)(RleStream *self)) KoalaStream_ReadCommand,
	RleStream_ReadValue
};

struct PacStream {
	RleStream base;
};
static void PacStream_Construct(PacStream *self, const RleStreamVtbl *vtbl);
static cibool PacStream_ReadCommand(PacStream *self);
static const RleStreamVtbl CiVtbl_PacStream = {
	(cibool (*)(RleStream *self)) PacStream_ReadCommand,
	RleStream_ReadValue
};

struct PackBitsStream {
	RleStream base;
};
static void PackBitsStream_Construct(PackBitsStream *self, const RleStreamVtbl *vtbl);
static cibool PackBitsStream_ReadCommand(PackBitsStream *self);
static const RleStreamVtbl CiVtbl_PackBitsStream = {
	(cibool (*)(RleStream *self)) PackBitsStream_ReadCommand,
	RleStream_ReadValue
};

struct TnyPcsStream {
	RleStream base;
};
static void TnyPcsStream_Construct(TnyPcsStream *self, const RleStreamVtbl *vtbl);
static cibool TnyPcsStream_ReadCommand(TnyPcsStream *self);
static const RleStreamVtbl CiVtbl_TnyPcsStream = {
	(cibool (*)(RleStream *self)) TnyPcsStream_ReadCommand,
	RleStream_ReadValue
};

struct PcsStream {
	TnyPcsStream base;
	cibool palette;
};
static void PcsStream_Construct(PcsStream *self, const RleStreamVtbl *vtbl);
static int PcsStream_ReadValue(PcsStream *self);
static cibool PcsStream_UnpackPcs(PcsStream *self, unsigned char *unpacked);
static const RleStreamVtbl CiVtbl_PcsStream = {
	(cibool (*)(RleStream *self)) TnyPcsStream_ReadCommand,
	(int (*)(RleStream *self)) PcsStream_ReadValue
};

struct PgcStream {
	RleStream base;
};
static void PgcStream_Construct(PgcStream *self, const RleStreamVtbl *vtbl);
static cibool PgcStream_ReadCommand(PgcStream *self);
static const RleStreamVtbl CiVtbl_PgcStream = {
	(cibool (*)(RleStream *self)) PgcStream_ReadCommand,
	RleStream_ReadValue
};

struct RgbStream {
	RleStream base;
};
static void RgbStream_Construct(RgbStream *self, const RleStreamVtbl *vtbl);
static cibool RgbStream_ReadCommand(RgbStream *self);
static int RgbStream_ReadValue(RgbStream *self);
static const RleStreamVtbl CiVtbl_RgbStream = {
	(cibool (*)(RleStream *self)) RgbStream_ReadCommand,
	(int (*)(RleStream *self)) RgbStream_ReadValue
};

struct SpcStream {
	RleStream base;
};
static void SpcStream_Construct(SpcStream *self, const RleStreamVtbl *vtbl);
static cibool SpcStream_ReadCommand(SpcStream *self);
static const RleStreamVtbl CiVtbl_SpcStream = {
	(cibool (*)(RleStream *self)) SpcStream_ReadCommand,
	RleStream_ReadValue
};

struct SpsStream {
	RleStream base;
};
static void SpsStream_Construct(SpsStream *self, const RleStreamVtbl *vtbl);
static cibool SpsStream_ReadCommand(SpsStream *self);
static const RleStreamVtbl CiVtbl_SpsStream = {
	(cibool (*)(RleStream *self)) SpsStream_ReadCommand,
	RleStream_ReadValue
};

struct TnyStream {
	TnyPcsStream base;
	int valueLength;
	int valueOffset;
};
static void TnyStream_Construct(TnyStream *self, const RleStreamVtbl *vtbl);
static int TnyStream_ReadValue(TnyStream *self);
static const RleStreamVtbl CiVtbl_TnyStream = {
	(cibool (*)(RleStream *self)) TnyPcsStream_ReadCommand,
	(int (*)(RleStream *self)) TnyStream_ReadValue
};

struct VdatStream {
	TnyStream base;
};
static void VdatStream_Construct(VdatStream *self, const RleStreamVtbl *vtbl);
static cibool VdatStream_ReadCommand(VdatStream *self);
static const RleStreamVtbl CiVtbl_VdatStream = {
	(cibool (*)(RleStream *self)) VdatStream_ReadCommand,
	(int (*)(RleStream *self)) TnyStream_ReadValue
};

struct XlpStream {
	RleStream base;
};
static void XlpStream_Construct(XlpStream *self, const RleStreamVtbl *vtbl);
static cibool XlpStream_ReadCommand(XlpStream *self);
static const RleStreamVtbl CiVtbl_XlpStream = {
	(cibool (*)(RleStream *self)) XlpStream_ReadCommand,
	RleStream_ReadValue
};

static void A4rStream_Construct(A4rStream *self)
{
	self->outerFlags = self->innerFlags = 0;
}

static cibool A4rStream_CopyBlock(A4rStream *self, int distance, int length)
{
	if (distance > self->unpackedOffset)
		return FALSE;
	do {
		if (!A4rStream_StoreByte(self, self->unpacked[self->unpackedOffset - distance]))
			return FALSE;
	}
	while (--length > 0);
	return TRUE;
}

static int A4rStream_ReadByte(A4rStream *self)
{
	if (self->contentOffset >= self->contentLength)
		return -1;
	return self->content[self->contentOffset++];
}

static int A4rStream_ReadFlag(A4rStream *self)
{
	if ((self->innerFlags & 127) == 0) {
		if ((self->outerFlags & 127) == 0) {
			if (self->contentOffset >= self->contentLength)
				return -1;
			self->outerFlags = (self->content[self->contentOffset++] << 1) | 1;
		}
		else
			self->outerFlags <<= 1;
		if ((self->outerFlags & 256) == 0)
			self->innerFlags = 1;
		else {
			if (self->contentOffset >= self->contentLength)
				return -1;
			self->innerFlags = (self->content[self->contentOffset++] << 1) | 1;
		}
	}
	else
		self->innerFlags <<= 1;
	return (self->innerFlags >> 8) & 1;
}

static cibool A4rStream_StoreByte(A4rStream *self, int value)
{
	if (self->unpackedOffset < 0 || self->unpackedOffset >= 11248)
		return FALSE;
	self->unpacked[self->unpackedOffset++] = value;
	return TRUE;
}

static cibool A4rStream_UnpackA4r(A4rStream *self)
{
	memset(self->unpacked, 0, sizeof(self->unpacked));
	self->unpackedOffset = -1;
	for (;;) {
		int b;
		switch (A4rStream_ReadFlag(self)) {
		case -1:
			return FALSE;
		case 0:
			b = A4rStream_ReadByte(self);
			if (b < 0)
				return FALSE;
			if (!A4rStream_StoreByte(self, b))
				return FALSE;
			break;
		case 1:
			b = A4rStream_ReadByte(self);
			switch (b) {
			case -1:
				return FALSE;
			case 0:
				if (self->contentOffset + 2 >= self->contentLength)
					return FALSE;
				b = A4rStream_ReadByte(self);
				self->unpackedOffset = b + (A4rStream_ReadByte(self) << 8) + 128 - 19984;
				if (!A4rStream_StoreByte(self, A4rStream_ReadByte(self)))
					return FALSE;
				break;
			case 1:
				b = A4rStream_ReadByte(self);
				switch (b) {
				case -1:
					return FALSE;
				case 0:
					return TRUE;
				default:
					if (!A4rStream_CopyBlock(self, 1, b + 2))
						return FALSE;
					break;
				}
				break;
			default:
				if (!A4rStream_CopyBlock(self, 128 - (b >> 1), 2 + (b & 1)))
					return FALSE;
				break;
			}
			break;
		}
	}
}

static void BitStream_Construct(BitStream *self)
{
	self->bits = 0;
}

static int BitStream_ReadBit(BitStream *self)
{
	if ((self->bits & 127) == 0) {
		if (self->contentOffset >= self->contentLength)
			return -1;
		self->bits = (self->content[self->contentOffset++] << 1) | 1;
	}
	else
		self->bits <<= 1;
	return (self->bits >> 8) & 1;
}

static int BitStream_ReadBits(BitStream *self, int count)
{
	int result = 0;
	while (--count >= 0) {
		int bit = BitStream_ReadBit(self);
		if (bit < 0)
			return -1;
		result = (result << 1) | bit;
	}
	return result;
}

static cibool BlazingPaddlesBoundingBox_Calculate(BlazingPaddlesBoundingBox *self, unsigned char const *content, int contentLength, int index, int startAddress)
{
	int contentOffset;
	int x;
	int y;
	if (index * 2 + 1 >= contentLength)
		return FALSE;
	contentOffset = content[index * 2] + (content[index * 2 + 1] << 8) - startAddress;
	if (contentOffset < 0)
		return FALSE;
	self->left = self->top = self->right = self->bottom = 0;
	x = 0;
	y = 0;
	while (contentOffset < contentLength) {
		int control = content[contentOffset++];
		int len;
		if (control == 8)
			return TRUE;
		len = (control >> 4) + 1;
		switch (control & 3) {
		case 0:
			x += len;
			if (self->right < x)
				self->right = x;
			break;
		case 1:
			x -= len;
			if (self->left > x)
				self->left = x;
			break;
		case 2:
			y -= len;
			if (self->top > y)
				self->top = y;
			break;
		case 3:
			y += len;
			if (self->bottom < y)
				self->bottom = y;
			break;
		}
	}
	return FALSE;
}

static void CaStream_Construct(CaStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_CaStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool CaStream_ReadCommand(CaStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	int c;
	if (b < 0)
		return FALSE;
	if (b != self->escapeByte) {
		self->base.repeatCount = 1;
		self->base.repeatValue = b;
		return TRUE;
	}
	c = RleStream_ReadByte(&self->base);
	if (c < 0)
		return FALSE;
	if (c == self->escapeByte) {
		self->base.repeatCount = 1;
		self->base.repeatValue = c;
		return TRUE;
	}
	b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	switch (c) {
	case 0:
		self->base.repeatCount = b + 1;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
		break;
	case 1:
		c = RleStream_ReadByte(&self->base);
		if (c < 0)
			return FALSE;
		self->base.repeatCount = (b << 8) + c + 1;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
		break;
	case 2:
		if (b == 0)
			self->base.repeatCount = 32000;
		else {
			c = RleStream_ReadByte(&self->base);
			if (c < 0)
				return FALSE;
			self->base.repeatCount = (b << 8) + c + 1;
		}
		self->base.repeatValue = self->defaultValue;
		break;
	default:
		self->base.repeatCount = c + 1;
		self->base.repeatValue = b;
		break;
	}
	return TRUE;
}

static cibool CaStream_UnpackCa(unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedOffset)
{
	CaStream rle;
	int unpackedStep;
	unsigned char isFilled[32000];
	if (contentOffset + 4 > contentLength)
		return FALSE;
	CaStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = contentOffset + 4;
	rle.base.base.contentLength = contentLength;
	rle.escapeByte = content[contentOffset];
	rle.defaultValue = content[contentOffset + 1];
	unpackedStep = (content[contentOffset + 2] << 8) | content[contentOffset + 3];
	if (unpackedStep >= 32000)
		return FALSE;
	if (unpackedStep == 0) {
		rle.base.repeatCount = 32000;
		rle.base.repeatValue = rle.defaultValue;
		unpackedStep = 1;
	}
	memset(isFilled, 0, sizeof(isFilled));
	{
		int offset;
		for (offset = 0;;) {
			int b = RleStream_ReadRle(&rle.base);
			if (b < 0)
				return FALSE;
			unpacked[unpackedOffset + offset] = b;
			isFilled[offset] = 1;
			offset += unpackedStep;
			if (offset >= 32000) {
				for (offset = 1; isFilled[offset] != 0; offset++)
					if (offset >= unpackedStep)
						return TRUE;
			}
		}
	}
}

static cibool CaStream_UnpackDel(unsigned char const *content, int contentLength, unsigned char *unpacked, int blocks)
{
	int contentOffset = blocks << 2;
	int unpackedOffset;
	if (contentOffset >= contentLength)
		return FALSE;
	unpackedOffset = 0;
	{
		int block;
		for (block = 0; block < blocks; block++) {
			int nextContentOffset = contentOffset + FAIL_Get32BigEndian(content, block << 2);
			if (!CaStream_UnpackCa(content, contentOffset, nextContentOffset, unpacked, unpackedOffset))
				return FALSE;
			contentOffset = nextContentOffset;
			unpackedOffset += 32000;
		}
	}
	if (blocks == 2) {
		if (!CaStream_UnpackCa(content, contentOffset, contentLength, unpacked, unpackedOffset))
			return FALSE;
	}
	return TRUE;
}

static void CciStream_Construct(CciStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_CciStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool CciStream_ReadCommand(CciStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		self->base.repeatCount = b + 1;
		self->base.repeatValue = -1;
	}
	else {
		self->base.repeatCount = b - 127;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
	}
	return TRUE;
}

static cibool CciStream_UnpackGr15(CciStream *self, unsigned char *unpacked, int unpackedOffset)
{
	self->base.base.contentOffset += 4;
	self->base.repeatCount = 0;
	{
		int offset;
		for (offset = 0;;) {
			int b = RleStream_ReadRle(&self->base);
			if (b < 0)
				return FALSE;
			unpacked[unpackedOffset + offset] = b;
			offset += 80;
			if (offset >= 7680) {
				offset -= 7679;
				if (offset >= 40)
					return TRUE;
			}
		}
	}
}

static void FAIL_Construct(FAIL *self)
{
	FAIL_SetAtari8Palette(self, NULL);
}

FAIL *FAIL_New(void)
{
	FAIL *self = (FAIL *) malloc(sizeof(FAIL));
	if (self != NULL)
		FAIL_Construct(self);
	return self;
}

void FAIL_Delete(FAIL *self)
{
	free(self);
}

static cibool FAIL_ApplyAtari8Palette(FAIL *self, unsigned char const *frame)
{
	int pixelsLength = self->width * self->height;
	{
		int i;
		for (i = 0; i < pixelsLength; i++)
			self->pixels[i] = self->atari8Palette[frame[i]];
	}
	return TRUE;
}

static cibool FAIL_ApplyAtari8PaletteBlend(FAIL *self, unsigned char const *frame1, unsigned char const *frame2)
{
	int pixelsLength = self->width * self->height;
	self->frames = 2;
	{
		int i;
		for (i = 0; i < pixelsLength; i++) {
			int rgb1 = self->atari8Palette[frame1[i]];
			int rgb2 = self->atari8Palette[frame2[i]];
			self->pixels[i] = (rgb1 & rgb2) + (((rgb1 ^ rgb2) >> 1) & 8355711);
		}
	}
	return TRUE;
}

static cibool FAIL_ApplyAtari8PaletteBlend3(FAIL *self, unsigned char const *frame1, unsigned char const *frame2, unsigned char const *frame3)
{
	int pixelsLength = self->width * self->height;
	self->frames = 3;
	{
		int i;
		for (i = 0; i < pixelsLength; i++) {
			int rgb1 = self->atari8Palette[frame1[i]];
			int rgb2 = self->atari8Palette[frame2[i]];
			int rgb3 = self->atari8Palette[frame3[i]];
			self->pixels[i] = (((rgb1 >> 16) + (rgb2 >> 16) + (rgb3 >> 16)) / 3 << 16) | ((((rgb1 >> 8) & 255) + ((rgb2 >> 8) & 255) + ((rgb3 >> 8) & 255)) / 3 << 8) | ((rgb1 & 255) + (rgb2 & 255) + (rgb3 & 255)) / 3;
		}
	}
	return TRUE;
}

static void FAIL_CalculatePalette(FAIL *self, int *palette, int paletteOffset, int paletteLength)
{
	int pixelsCount = self->width * self->height;
	{
		int pixelsOffset;
		for (pixelsOffset = 0; pixelsOffset < pixelsCount; pixelsOffset++) {
			int rgb = self->pixels[pixelsOffset];
			int index = FAIL_FindColor(palette, paletteOffset, rgb);
			if (index >= paletteOffset || palette[index] != rgb) {
				if (paletteOffset == paletteLength) {
					self->colors = 0;
					return;
				}
				{
					int j;
					for (j = paletteOffset; --j >= index;)
						palette[j + 1] = palette[j];
				}
				palette[index] = rgb;
				paletteOffset++;
			}
		}
	}
	self->colors = paletteOffset;
}

cibool FAIL_Decode(FAIL *self, const char *filename, unsigned char const *content, int contentLength)
{
	switch (FAIL_GetPackedExt(filename)) {
	case 3552562:
		return FAIL_Decode256(self, content, contentLength);
	case 6909236:
		return FAIL_Decode4mi(self, content, contentLength);
	case 7106612:
		return FAIL_Decode4pl(self, content, contentLength);
	case 7172148:
		return FAIL_Decode4pm(self, content, contentLength);
	case 7484513:
		return FAIL_DecodeA4r(self, content, contentLength);
	case 7562081:
		return FAIL_DecodeAcs(self, content, contentLength);
	case 7366497:
		return FAIL_DecodeAgp(self, content, contentLength);
	case 7105633:
		return FAIL_DecodeAll(self, content, contentLength);
	case 3305569:
		return FAIL_Decode256(self, content, contentLength);
	case 3371105:
	case 7762017:
	case 7366500:
	case 6517605:
	case 6515817:
	case 7174768:
		return FAIL_DecodeAp3(self, content, contentLength);
	case 6516833:
		return FAIL_DecodeApc(self, content, contentLength);
	case 7106657:
		return FAIL_DecodeApl(self, content, contentLength);
	case 7368801:
		return FAIL_DecodeApp(self, content, contentLength);
	case 7631457:
		return FAIL_DecodeArtDirector(self, content, contentLength) || FAIL_DecodeAtari8Artist(self, content, contentLength) || FAIL_DecodeAsciiArtEditor(self, content, contentLength);
	case 3762018:
	case 3747943:
		return FAIL_DecodeG09(self, content, contentLength);
	case 6777698:
		return FAIL_DecodeBkg(self, content, contentLength);
	case 7696994:
		return FAIL_DecodeBru(self, content, contentLength);
	case 3236195:
	case 3301731:
	case 3367267:
		return FAIL_DecodeCa(self, content, contentLength);
	case 6906723:
		return FAIL_DecodeCci(self, content, contentLength);
	case 7497827:
		return FAIL_DecodeChr(self, content, contentLength);
	case 7235939:
		return FAIL_DecodeCin(self, content, contentLength);
	case 7499875:
		return FAIL_DecodeCpr(self, content, contentLength);
	case 7630947:
		return FAIL_DecodeCpt(self, content, contentLength);
	case 3236708:
	case 6514532:
		return FAIL_DecodeDgc(self, content, contentLength);
	case 7103844:
		return FAIL_DecodeDel(self, content, contentLength);
	case 3237732:
	case 7694180:
		return FAIL_DecodeDgu(self, content, contentLength);
	case 7235940:
		return FAIL_DecodeDin(self, content, contentLength);
	case 7171172:
		return FAIL_DecodeDlm(self, content, contentLength);
	case 7303012:
		return FAIL_DecodeDoo(self, content, contentLength);
	case 6844516:
		return FAIL_DecodeDph(self, content, contentLength);
	case 6779492:
		return FAIL_DecodeDrg(self, content, contentLength);
	case 7630438:
		return FAIL_DecodeFnt(self, content, contentLength);
	case 6517862:
		return FAIL_DecodeFtc(self, content, contentLength);
	case 6387558:
		return FAIL_DecodeFwa(self, content, contentLength);
	case 6776935:
		return FAIL_DecodeGhg(self, content, contentLength);
	case 6582119:
		return FAIL_DecodeGod(self, content, contentLength);
	case 3158375:
		return FAIL_DecodeG10(self, content, contentLength);
	case 3223911:
		return FAIL_DecodeG11(self, content, contentLength);
	case 6448743:
		return FAIL_DecodeGfb(self, content, contentLength);
	case 3633767:
		return FAIL_DecodeGr7(self, content, 0, contentLength);
	case 3699303:
		return FAIL_DecodeGr8(self, content, contentLength);
	case 3764839:
		return FAIL_DecodeGr9(self, content, contentLength);
	case 7367016:
		return FAIL_DecodeHip(self, content, contentLength);
	case 7172200:
		return FAIL_DecodeHpm(self, content, contentLength);
	case 2126440:
		return FAIL_DecodeHr(self, content, contentLength);
	case 3306088:
		return FAIL_DecodeHr2(self, content, contentLength);
	case 7234409:
		return FAIL_DecodeStIcn(self, content, contentLength) || FAIL_DecodeAtari8Icn(self, content, contentLength);
	case 6710889:
	case 3239010:
	case 3304546:
	case 3370082:
		return FAIL_DecodeIff(self, content, contentLength);
	case 6645609:
		return FAIL_DecodeIge(self, content, contentLength);
	case 7236969:
		return FAIL_DecodeImn(self, content, contentLength);
	case 6778473:
	case 7368297:
		return FAIL_DecodeInp(self, content, contentLength);
	case 7630441:
		return FAIL_DecodeInt(self, content, contentLength) || FAIL_DecodeInp(self, content, contentLength);
	case 3305577:
		return FAIL_DecodeIp2(self, content, contentLength);
	case 6516841:
		return FAIL_DecodeIpc(self, content, contentLength);
	case 3306089:
		return FAIL_DecodeIr2(self, content, contentLength);
	case 6779497:
		return FAIL_DecodeIrg(self, content, contentLength);
	case 7631721:
		return FAIL_DecodeIst(self, content, contentLength);
	case 7366506:
		return FAIL_DecodeJgp(self, content, contentLength);
	case 7889261:
		return FAIL_DecodeMax(self, content, contentLength);
	case 6775405:
		return FAIL_DecodeMbg(self, content, contentLength);
	case 6841197:
		return FAIL_DecodeMch(self, content, contentLength);
	case 7365485:
		return FAIL_DecodeMcp(self, content, contentLength);
	case 7562093:
		return FAIL_DecodeMcs(self, content, contentLength);
	case 7366509:
		return FAIL_DecodeMgp(self, content, contentLength);
	case 6515053:
		return FAIL_DecodeMic(self, content, contentLength);
	case 7563629:
		return FAIL_DecodeMis(self, content, contentLength);
	case 7300462:
		return FAIL_DecodeNeo(self, content, contentLength);
	case 7433326:
		return FAIL_DecodeNlq(self, content, contentLength);
	case 6513008:
		return FAIL_DecodePac(self, content, contentLength);
	case 3236720:
	case 3302256:
	case 3367792:
		return FAIL_DecodePc(self, content, contentLength);
	case 7562096:
		return FAIL_DecodePcs(self, content, contentLength);
	case 6514544:
		return FAIL_DecodePgc(self, content, contentLength);
	case 6711152:
		return FAIL_DecodePgf(self, content, contentLength);
	case 3238256:
	case 3303792:
	case 3369328:
		return FAIL_DecodePi(self, content, contentLength);
	case 3434864:
	case 3762544:
		return FAIL_DecodePi4(self, content, contentLength);
	case 6515056:
		return FAIL_DecodePic(self, content, contentLength);
	case 6384752:
		return FAIL_DecodePla(self, content, contentLength);
	case 7171184:
		return FAIL_DecodeApc(self, content, contentLength);
	case 6581616:
		return FAIL_DecodePmd(self, content, contentLength);
	case 7823730:
		return FAIL_DecodeRaw(self, content, contentLength);
	case 6449010:
		return FAIL_DecodeRgb(self, content, contentLength);
	case 7367026:
		return FAIL_DecodeRip(self, content, contentLength);
	case 3173746:
		return FAIL_DecodeRm(self, content, contentLength, 0, FAILResolution_XE2X2);
	case 3239282:
		return FAIL_DecodeRm(self, content, contentLength, 1, FAILResolution_XE4X1);
	case 3304818:
		return FAIL_DecodeRm(self, content, contentLength, 2, FAILResolution_XE4X1);
	case 3370354:
		return FAIL_DecodeRm(self, content, contentLength, 3, FAILResolution_XE4X1);
	case 3435890:
		return FAIL_DecodeRm(self, content, contentLength, 4, FAILResolution_XE2X1);
	case 6645619:
		return FAIL_DecodeSge(self, content, contentLength);
	case 6514803:
		return FAIL_DecodeShc(self, content, contentLength);
	case 7366771:
		return FAIL_DecodeShp(self, content, contentLength);
	case 6516851:
		return FAIL_DecodeStSpc(self, content, contentLength) || FAIL_DecodeAtari8Spc(self, content, contentLength);
	case 7565427:
		return FAIL_DecodeSps(self, content, contentLength);
	case 7696499:
		return FAIL_DecodeSpu(self, content, contentLength);
	case 7567475:
		return FAIL_DecodeSxs(self, content, contentLength);
	case 7367028:
		return FAIL_DecodeTip(self, content, contentLength);
	case 3239540:
	case 3305076:
	case 3370612:
	case 7958132:
		return FAIL_DecodeTny(self, content, contentLength);
	case 7369332:
		return FAIL_DecodeTrp(self, content, contentLength);
	case 7697012:
		return FAIL_DecodeTru(self, content, contentLength);
	case 6912630:
		return FAIL_DecodeVzi(self, content, contentLength);
	case 6581879:
		return FAIL_DecodeWnd(self, content, contentLength);
	case 7367800:
		return FAIL_DecodeXlp(self, content, contentLength);
	default:
		return FALSE;
	}
}

static cibool FAIL_Decode256(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	if (contentLength != 7680 && contentLength != 7684)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE4X2);
	self->gtiaColors[8] = 0;
	FAIL_DecodeAtari8Gr9(self, content, 3840, 40, frame, 320, 640, 320, 96);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 0, 40, frame, 0);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_Decode4mi(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[7680];
	if (contentLength != 244)
		return FALSE;
	FAIL_SetSize(self, 32, 240, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	FAIL_DecodeAt800Missiles(self, content, 4, frame, 0);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_Decode4pl(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[19200];
	if (contentLength != 964)
		return FALSE;
	FAIL_SetSize(self, 80, 240, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	FAIL_DecodeAt800Players(self, content, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_Decode4pm(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[26880];
	if (contentLength != 1204)
		return FALSE;
	FAIL_SetSize(self, 112, 240, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	FAIL_DecodeAt800Players(self, content, frame);
	FAIL_DecodeAt800Missiles(self, content, 964, frame, 80);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeA4r(FAIL *self, unsigned char const *content, int contentLength)
{
	A4rStream a4r;
	unsigned char frame[81920];
	A4rStream_Construct(&a4r);
	a4r.content = content;
	a4r.contentOffset = 0;
	a4r.contentLength = contentLength;
	if (!A4rStream_UnpackA4r(&a4r))
		return FALSE;
	FAIL_SetSize(self, 320, 256, FAILResolution_XE4X1);
	self->gtiaColors[8] = 0;
	FAIL_DecodeAtari8Gr9(self, a4r.unpacked, 512, 40, frame, 0, 320, 320, 256);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeAcs(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char characters[16];
	unsigned char frame[8192];
	if (contentLength != 1028)
		return FALSE;
	{
		int i;
		for (i = 0; i < 16; i++)
			characters[i] = i;
	}
	FAIL_SetBakPF012(self, content, 0, 1);
	FAIL_SetSize(self, 128, 64, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 8; y++)
			FAIL_DecodeAtari8Gr12Line(self, characters, 0, content, 4 + (y << 7), frame, y << 10);
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeAgp(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	if (contentLength != 7690)
		return FALSE;
	FAIL_SetGtiaColors(self, content, 1);
	switch (content[0]) {
	case 8:
		FAIL_SetSize(self, 320, 192, FAILResolution_XE1X1);
		FAIL_DecodeAtari8Gr8(self, content, 10, frame);
		break;
	case 9:
		FAIL_SetSize(self, 320, 192, FAILResolution_XE4X1);
		FAIL_DecodeAtari8Gr9(self, content, 10, 40, frame, 0, 320, 320, 192);
		break;
	case 10:
		FAIL_SetSize(self, 320, 192, FAILResolution_XE4X1);
		self->gtiaLeftSkip = 2;
		FAIL_DecodeAtari8Gr10(self, content, 10, frame, 0, 320, 192);
		break;
	case 11:
		FAIL_SetSize(self, 320, 192, FAILResolution_XE4X1);
		FAIL_DecodeAtari8Gr11(self, content, 10, frame, 0, 320, 192);
		break;
	case 15:
		FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
		FAIL_DecodeAtari8Gr15(self, content, 10, 40, frame, 0, 320, 192);
		break;
	default:
		return FALSE;
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeAll(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	if ((contentLength & 1023) != 989)
		return FALSE;
	FAIL_SetPF0123Bak(self, content, contentLength - 5);
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 24; y++) {
			int fontOffset = 24 + (content[y] << 10);
			if (fontOffset >= contentLength - 965)
				return FALSE;
			FAIL_DecodeAtari8Gr12Line(self, content, contentLength - 965 + y * 40, content, fontOffset, frame, y * 2560);
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeAp3(FAIL *self, unsigned char const *content, int contentLength)
{
	int gr11Offset;
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	switch (contentLength) {
	case 15360:
	case 15362:
		gr11Offset = 7680;
		break;
	case 15872:
		gr11Offset = 8192;
		break;
	default:
		return FALSE;
	}
	FAIL_SetSize(self, 320, 192, FAILResolution_XE4X1);
	self->gtiaColors[8] = 0;
	FAIL_DecodeAtari8Gr9(self, content, 0, 80, frame1, 0, 640, 320, 96);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, gr11Offset + 40, 80, frame1, 1);
	FAIL_DecodeAtari8Gr9(self, content, 40, 80, frame2, 320, 640, 320, 96);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, gr11Offset, 80, frame2, 0);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeApc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	if (contentLength != 7680 && contentLength != 7720)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE4X2);
	self->gtiaColors[8] = 0;
	FAIL_DecodeAtari8Gr9(self, content, 40, 80, frame, 320, 640, 320, 96);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 0, 80, frame, 0);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeApl(FAIL *self, unsigned char const *content, int contentLength)
{
	int frames;
	int height;
	int gap;
	int frameWidth;
	unsigned char frame[27648];
	if (contentLength != 1677 || content[0] != 154 || content[1] != 248 || content[2] != 57 || content[3] != 33)
		return FALSE;
	frames = content[4];
	height = content[5];
	gap = content[6];
	if (frames == 0 || frames > 16 || height == 0 || height > 48 || gap > 8)
		return FALSE;
	frameWidth = (8 + gap + 2) << 1;
	FAIL_SetSize(self, frames * frameWidth, height, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	{
		int f;
		for (f = 0; f < frames; f++) {
			FAIL_DecodeAtari8Player(self, content, 42 + f * 48, content[7 + f], frame, f * frameWidth, height);
			FAIL_DecodeAtari8Player(self, content, 858 + f * 48, content[24 + f], frame, f * frameWidth + gap * 2, height);
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeApp(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[15872];
	int unpackedOffset;
	BitStream bitStream;
	int current;
	int hi;
	if (contentLength < 7958 || !FAIL_IsStringAt(content, 0, "S101") || content[4] != 0 || content[5] != 62)
		return FALSE;
	unpackedOffset = 0;
	BitStream_Construct(&bitStream);
	bitStream.content = content;
	bitStream.contentOffset = 22;
	bitStream.contentLength = contentLength;
	current = BitStream_ReadBits(&bitStream, 4);
	hi = -1;
	for (;;) {
		int code;
		int bit;
		if (hi < 0)
			hi = current;
		else {
			unpacked[unpackedOffset++] = (hi << 4) | current;
			if (unpackedOffset >= 15872)
				break;
			hi = -1;
		}
		for (code = 0;; code += 2) {
			bit = BitStream_ReadBit(&bitStream);
			if (bit == 0)
				break;
			if (bit < 0 || code >= 14)
				return FALSE;
		}
		bit = BitStream_ReadBit(&bitStream);
		if (bit < 0)
			return FALSE;
		code += bit;
		current = (current - content[6 + code]) & 15;
	}
	return FAIL_DecodeAp3(self, unpacked, 15872);
}

static cibool FAIL_DecodeArtDirector(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 32512)
		return FALSE;
	return FAIL_DecodeStLow(self, content, 0, content, 32000, 320, 200);
}

static cibool FAIL_DecodeAsciiArtEditor(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char characters[1536];
	int columns;
	int x;
	int y;
	unsigned char frame[98304];
	if (contentLength <= 0 || content[contentLength - 1] != 155)
		return FALSE;
	columns = 1;
	x = 0;
	y = 0;
	{
		int contentOffset;
		for (contentOffset = 0; contentOffset < contentLength; contentOffset++) {
			int ch = content[contentOffset];
			if (y >= 24)
				return FALSE;
			if (ch == 155) {
				if (columns < x)
					columns = x;
				while (x < 64)
					characters[y * 64 + x++] = 0;
				x = 0;
				y++;
			}
			else {
				if (x >= 64)
					return FALSE;
				characters[y * 64 + x++] = FAIL_ToAtari8Char(ch);
			}
		}
	}
	FAIL_SetSize(self, columns << 3, y << 3, FAILResolution_XE1X1);
	FAIL_DecodeAtari8Gr0(self, characters, 64, CiBinaryResource_atari8_fnt, 0, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static void FAIL_DecodeAt800Missiles(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset)
{
	{
		int y;
		for (y = 0; y < 240; y++) {
			{
				int i;
				for (i = 0; i < 4; i++) {
					int b = content[contentOffset + y] >> (i << 1);
					int offset = frameOffset + i * 4 * 2;
					frame[offset + 1] = frame[offset] = (b & 2) == 0 ? 0 : content[i];
					frame[offset + 3] = frame[offset + 2] = (b & 1) == 0 ? 0 : content[i];
				}
			}
			frameOffset += self->width;
		}
	}
}

static void FAIL_DecodeAt800Players(FAIL const *self, unsigned char const *content, unsigned char *frame)
{
	{
		int i;
		for (i = 0; i < 4; i++)
			FAIL_DecodeAtari8Player(self, content, 4 + i * 240, content[i], frame, i * 10 * 2, 240);
	}
}

static cibool FAIL_DecodeAtari8Artist(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[51200];
	if (contentLength != 3206 || content[0] != 7)
		return FALSE;
	FAIL_SetSize(self, 320, 160, FAILResolution_XE2X2);
	FAIL_SetPF0123Bak(self, content, 1);
	FAIL_DecodeAtari8Gr7(self, content, 6, frame, 0, 80);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeAtari8Font(FAIL *self, unsigned char const *characters, unsigned char const *font, int fontOffset)
{
	unsigned char frame[8192];
	FAIL_SetSize(self, 256, 32, FAILResolution_XE1X1);
	FAIL_DecodeAtari8Gr0(self, characters, 32, font, fontOffset, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static void FAIL_DecodeAtari8Gr0(FAIL const *self, unsigned char const *characters, int charactersStride, unsigned char const *font, int fontOffset, unsigned char *frame)
{
	{
		int y;
		for (y = 0; y < self->height; y++) {
			{
				int x;
				for (x = 0; x < self->width; x++) {
					int ch = characters[(y >> 3) * charactersStride + (x >> 3)];
					int b = font[fontOffset + ((ch & 127) << 3) + (y & 7)];
					if (ch >= 128)
						b ^= 255;
					frame[y * self->width + x] = ((b >> (~x & 7)) & 1) == 0 ? 0 : 14;
				}
			}
		}
	}
}

static void FAIL_DecodeAtari8Gr10(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int frameStride, int height)
{
	frameOffset += 2 - self->gtiaLeftSkip;
	{
		int y;
		for (y = 0; y < height; y++) {
			int x;
			for (x = self->gtiaLeftSkip - 2; x < 0; x++)
				frame[frameOffset + x] = self->gtiaColors[0];
			for (; x < self->width + self->gtiaLeftSkip - 2; x++) {
				int c = (content[contentOffset + (x >> 3)] >> (~x & 4)) & 15;
				frame[frameOffset + x] = self->gtiaColors[c];
			}
			contentOffset += self->width >> 3;
			frameOffset += frameStride;
		}
	}
}

static void FAIL_DecodeAtari8Gr11(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int frameStride, int height)
{
	frameOffset -= self->gtiaLeftSkip;
	{
		int y;
		for (y = 0; y < height; y++) {
			int x;
			for (x = self->gtiaLeftSkip; x < self->width; x++) {
				int c = (content[contentOffset + (x >> 3)] << (x & 4)) & 240;
				c = c == 0 ? self->gtiaColors[8] & 240 : self->gtiaColors[8] | c;
				frame[frameOffset + x] = c;
			}
			for (; x < self->width + self->gtiaLeftSkip; x++)
				frame[frameOffset + x] = self->gtiaColors[8] & 240;
			contentOffset += self->width >> 3;
			frameOffset += frameStride;
		}
	}
}

static void FAIL_DecodeAtari8Gr11PalBlend(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int y)
{
	for (; y < self->height; y += 2) {
		int frameOffset = y * self->width - self->gtiaLeftSkip;
		int x;
		for (x = self->gtiaLeftSkip; x < self->width; x++) {
			int c = (content[contentOffset + (x >> 3)] << (x & 4)) & 240;
			int i = ((y == 0 ? 0 : frame[frameOffset - self->width + x] & 15) + (y == self->height - 1 ? 0 : frame[frameOffset + self->width + x] & 15)) >> 1;
			frame[frameOffset + x] = c | i;
			if (y < self->height - 1)
				frame[frameOffset + self->width + x] = c | (frame[frameOffset + self->width + x] & 15);
		}
		for (; x < self->width + self->gtiaLeftSkip; x++)
			frame[frameOffset + x] = 0;
		contentOffset += contentStride;
	}
}

static void FAIL_DecodeAtari8Gr12(FAIL const *self, unsigned char const *content, int charactersOffset, int fontOffset, unsigned char *frame)
{
	{
		int row;
		for (row = 0; row < 24; row++)
			FAIL_DecodeAtari8Gr12Line(self, content, charactersOffset + row * 40, content, fontOffset + (row / 3 << 11), frame, row * 2560);
	}
}

static void FAIL_DecodeAtari8Gr12Line(FAIL const *self, unsigned char const *characters, int charactersOffset, unsigned char const *font, int fontOffset, unsigned char *frame, int frameOffset)
{
	{
		int y;
		for (y = 0; y < 8; y++) {
			{
				int x;
				for (x = 0; x < self->width; x++) {
					int ch = characters[charactersOffset + (x >> 3)];
					int c = (font[fontOffset + ((ch & 127) << 3) + y] >> (~x & 6)) & 3;
					int gr12Registers = ch >= 128 ? 30024 : 25928;
					frame[frameOffset + x] = self->gtiaColors[(gr12Registers >> (c << 2)) & 15] & 254;
				}
			}
			frameOffset += self->width;
		}
	}
}

static void FAIL_DecodeAtari8Gr15(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int frameOffset, int frameStride, int height)
{
	{
		int y;
		for (y = 0; y < height; y++) {
			{
				int x;
				for (x = 0; x < self->width; x++) {
					int c = (content[contentOffset + (x >> 3)] >> (~x & 6)) & 3;
					frame[frameOffset + x] = self->gtiaColors[c == 0 ? 8 : c + 3];
				}
			}
			contentOffset += contentStride;
			frameOffset += frameStride;
		}
	}
}

static void FAIL_DecodeAtari8Gr7(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame, int frameOffset, int height)
{
	{
		int y;
		for (y = 0; y < height; y++) {
			{
				int x;
				for (x = 0; x < self->width; x++) {
					int c = (content[contentOffset + (x >> 3)] >> (~x & 6)) & 3;
					frame[frameOffset + x + self->width] = frame[frameOffset + x] = self->gtiaColors[c == 0 ? 8 : c + 3];
				}
			}
			contentOffset += self->width >> 3;
			frameOffset += self->width << 1;
		}
	}
}

static void FAIL_DecodeAtari8Gr8(FAIL const *self, unsigned char const *content, int contentOffset, unsigned char *frame)
{
	unsigned char colors[2];
	int pixelsLength;
	colors[0] = self->gtiaColors[6];
	colors[1] = (self->gtiaColors[6] & 240) | (self->gtiaColors[5] & 14);
	pixelsLength = self->width * self->height;
	{
		int i;
		for (i = 0; i < pixelsLength; i++) {
			int c = (content[contentOffset + (i >> 3)] >> (~i & 7)) & 1;
			frame[i] = colors[c];
		}
	}
}

static void FAIL_DecodeAtari8Gr9(FAIL const *self, unsigned char const *content, int contentOffset, int contentStride, unsigned char *frame, int frameOffset, int frameStride, int width, int height)
{
	{
		int y;
		for (y = 0; y < height; y++) {
			{
				int x;
				for (x = 0; x < width; x++) {
					int i = x + self->gtiaLeftSkip;
					int c = i < 0 || i >= width ? 0 : (content[contentOffset + (i >> 3)] >> (~i & 4)) & 15;
					frame[frameOffset + x] = self->gtiaColors[8] | c;
				}
			}
			contentOffset += contentStride;
			frameOffset += frameStride;
		}
	}
}

static cibool FAIL_DecodeAtari8Icn(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char screen2[7680];
	unsigned char frame2[61440];
	if (contentLength != 17350 || content[0] != 1)
		return FALSE;
	FAIL_SetBakPF0123(self, content, 1);
	FAIL_DecodeIce(self, content, 6, frame1, screen2);
	FAIL_DecodeAtari8Gr11(self, screen2, 0, frame2, 0, 320, 192);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static void FAIL_DecodeAtari8Player(FAIL const *self, unsigned char const *content, int contentOffset, int color, unsigned char *frame, int frameOffset, int height)
{
	color &= 254;
	{
		int y;
		for (y = 0; y < height; y++) {
			int b = content[contentOffset + y];
			{
				int x;
				for (x = 0; x < 8; x++) {
					int c = (b >> (7 - x)) & 1;
					if (c != 0)
						frame[frameOffset + x * 2 + 1] = frame[frameOffset + x * 2] |= color;
				}
			}
			frameOffset += self->width;
		}
	}
}

static cibool FAIL_DecodeAtari8Spc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char pixels[30720];
	int lineColors[96];
	int textX;
	int textY;
	int lineX;
	int lineY;
	int brush;
	int pattern;
	int lineColor;
	int x;
	int y;
	unsigned char frame[61440];
	if (contentLength < 3 || contentLength != content[0] + (content[1] << 8) + 3 || content[contentLength - 1] != 0)
		return FALSE;
	memset(pixels, 0, sizeof(pixels));
	memset(lineColors, 0, sizeof(lineColors));
	textX = 0;
	textY = 0;
	lineX = 0;
	lineY = 0;
	brush = 0;
	pattern = 8840;
	lineColor = 3;
	{
		int contentOffset;
		for (contentOffset = 2; content[contentOffset] != 0;) {
			switch (content[contentOffset]) {
				static const int patterns[71] = { 0, 21845, 43690, 65535, 4420, 8840, 13260, 26265, 30685, 48110, 5457, 10914, 16371, 16388, 27302, 32759,
					32776, 38233, 49147, 49164, 54621, 60078, 21896, 8908, 13124, 17561, 17629, 30617, 35054, 34918, 39406, 52343,
					52411, 56763, 7089, 5465, 5469, 38237, 16392, 16396, 32780, 27308, 10926, 27298, 32763, 16379, 49143, 21892,
					8900, 13128, 17553, 17617, 30609, 35042, 34914, 39393, 52339, 52403, 56755, 21900, 8904, 13132, 17565, 17625,
					30621, 35046, 34926, 39397, 52347, 52407, 56759 };
			case 16:
				if (contentOffset + 3 >= contentLength)
					return FALSE;
				textX = content[contentOffset + 1];
				textY = content[contentOffset + 2];
				contentOffset += 3;
				break;
			case 32:
			case 33:
			case 34:
			case 35:
				if (contentOffset + 1 >= contentLength)
					return FALSE;
				lineColor = content[contentOffset] & 3;
				contentOffset++;
				break;
			case 48:
			case 80:
				if (contentOffset + 2 >= contentLength)
					return FALSE;
				FAIL_DrawSpcChar(pixels, textX, textY, content[contentOffset + 1]);
				textX += 4;
				contentOffset += 2;
				break;
			case 64:
			case 65:
			case 66:
			case 67:
			case 68:
			case 69:
			case 70:
			case 71:
				if (contentOffset + 1 >= contentLength)
					return FALSE;
				brush = content[contentOffset] & 7;
				contentOffset++;
				break;
			case 96:
				if (contentOffset + 2 >= contentLength)
					return FALSE;
				pattern = content[contentOffset + 1];
				if (pattern >= 71)
					return FALSE;
				pattern = patterns[pattern];
				contentOffset += 2;
				break;
			case 112:
				if (contentOffset + 7 >= contentLength)
					return FALSE;
				for (y = content[contentOffset + 1]; y <= content[contentOffset + 2]; y++) {
					if (y >= 96)
						return FALSE;
					lineColors[y] = contentOffset + 3;
				}
				contentOffset += 7;
				break;
			case 128:
				if (contentOffset + 3 >= contentLength)
					return FALSE;
				lineX = content[contentOffset + 1];
				lineY = content[contentOffset + 2];
				contentOffset += 3;
				break;
			case 160:
				if (contentOffset + 3 >= contentLength)
					return FALSE;
				x = content[contentOffset + 1];
				y = content[contentOffset + 2];
				FAIL_DrawSpcLine(pixels, lineX, lineY, x, y, lineColor);
				lineX = x;
				lineY = y;
				contentOffset += 3;
				break;
			case 192:
				if (contentOffset + 3 >= contentLength)
					return FALSE;
				FAIL_DrawSpcBrush(pixels, content[contentOffset + 1], content[contentOffset + 2], brush, pattern);
				contentOffset += 3;
				break;
			case 224:
				if (contentOffset + 3 >= contentLength)
					return FALSE;
				if (!FAIL_FillSpc(pixels, content[contentOffset + 1], content[contentOffset + 2], pattern))
					return FALSE;
				contentOffset += 3;
				break;
			default:
				return FALSE;
			}
		}
	}
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	for (y = 0; y < 192; y++) {
		static const unsigned char defaultColors[4] = { 0, 21, 149, 54 };
		int colorsOffset = lineColors[y >> 1];
		unsigned char const *colors = colorsOffset == 0 ? defaultColors : content;
		for (x = 0; x < 160; x++) {
			int offset = y * 320 + x * 2;
			frame[offset + 1] = frame[offset] = colors[colorsOffset + pixels[y * 160 + x]] & 254;
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static void FAIL_DecodeBitplanes(FAIL *self, unsigned char const *content, int contentOffset, int bitplanes, int pixelsOffset, int pixelsCount)
{
	{
		int i;
		for (i = 0; i < pixelsCount; i++) {
			int offset = contentOffset + ((i >> 3) & ~1) * bitplanes + ((i >> 3) & 1);
			int bit = ~i & 7;
			int c = 0;
			{
				int bitplane;
				for (bitplane = bitplanes; --bitplane >= 0;)
					c = (c << 1) | ((content[offset + (bitplane << 1)] >> bit) & 1);
			}
			self->pixels[pixelsOffset + i] = self->atari16Palette[c];
		}
	}
}

static cibool FAIL_DecodeBkg(FAIL *self, unsigned char const *content, int contentLength)
{
	return contentLength == 3856 && FAIL_DecodeGr7(self, content, 0, 3844);
}

static void FAIL_DecodeBlackAndWhite(FAIL *self, unsigned char const *content, int contentOffset, int width, int height, FAILResolution resolution)
{
	FAIL_SetSize(self, width, height, resolution);
	self->atari16Palette[0] = 16777215;
	self->atari16Palette[1] = 0;
	FAIL_DecodeBitplanes(self, content, contentOffset, 1, 0, width * height);
}

static cibool FAIL_DecodeBlazingPaddlesVectors(FAIL *self, unsigned char const *content, int contentLength, int startAddress)
{
	int x = 0;
	int y = 0;
	int i;
	int lineI = 0;
	int lineTop = 0;
	int lineBottom = 0;
	int xs[256];
	int ys[256];
	int width = 0;
	BlazingPaddlesBoundingBox box;
	unsigned char frame[76800];
	for (i = 0; i < 256; i++) {
		int shapeWidth;
		if (!BlazingPaddlesBoundingBox_Calculate(&box, content, contentLength, i, startAddress))
			break;
		shapeWidth = box.right - box.left + 2;
		if (x + shapeWidth > 160) {
			y -= lineTop;
			while (lineI < i)
				ys[lineI++] = y;
			if (width < x)
				width = (x + 3) & ~3;
			x = 0;
			y += lineBottom + 2;
			lineTop = box.top;
			lineBottom = box.bottom;
		}
		xs[i] = x - box.left;
		x += shapeWidth;
		if (lineTop > box.top)
			lineTop = box.top;
		if (lineBottom < box.bottom)
			lineBottom = box.bottom;
	}
	y -= lineTop;
	while (lineI < i)
		ys[lineI++] = y;
	if (width < x)
		width = (x + 3) & ~3;
	y += lineBottom + 1;
	if (i == 0 || y > 240)
		return FALSE;
	FAIL_SetSize(self, width * 2, y, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	for (i = 0; i < 256; i++) {
		if (!FAIL_DrawBlazingPaddlesVector(self, content, contentLength, frame, (ys[i] * width + xs[i]) * 2, i, startAddress))
			break;
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeBru(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 64)
		return FALSE;
	FAIL_SetSize(self, 8, 8, FAILResolution_ST1X1);
	{
		int i;
		for (i = 0; i < 64; i++) {
			switch (content[i]) {
			case 0:
				self->pixels[i] = 0;
				break;
			case 1:
				self->pixels[i] = 16777215;
				break;
			default:
				return FALSE;
			}
		}
	}
	return TRUE;
}

static cibool FAIL_DecodeCa(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	if (contentLength < 8 || content[0] != 67 || content[1] != 65)
		return FALSE;
	switch (content[3]) {
	case 0:
		contentOffset = 36;
		break;
	case 1:
		contentOffset = 12;
		break;
	case 2:
		contentOffset = 4;
		break;
	default:
		return FALSE;
	}
	switch (content[2]) {
		unsigned char unpacked[32000];
	case 0:
		if (contentOffset + 32000 != contentLength)
			return FALSE;
		return FAIL_DecodeSt(self, content, contentOffset, content, 4, content[3]);
	case 1:
		if (!CaStream_UnpackCa(content, contentOffset, contentLength, unpacked, 0))
			return FALSE;
		return FAIL_DecodeSt(self, unpacked, 0, content, 4, content[3]);
	default:
		return FALSE;
	}
}

static cibool FAIL_DecodeCci(FAIL *self, unsigned char const *content, int contentLength)
{
	CciStream rle;
	unsigned char unpacked[16384];
	if (contentLength < 24 || !FAIL_IsStringAt(content, 0, "CIN 1.2 "))
		return FALSE;
	CciStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 8;
	rle.base.base.contentLength = contentLength;
	if (!CciStream_UnpackGr15(&rle, unpacked, 0))
		return FALSE;
	if (!CciStream_UnpackGr15(&rle, unpacked, 40))
		return FALSE;
	rle.base.base.contentOffset += 4;
	rle.base.repeatCount = 0;
	if (!RleStream_Unpack(&rle.base, unpacked, 7680, 40, 7680))
		return FALSE;
	rle.base.base.contentOffset += 4;
	rle.base.repeatCount = 0;
	if (!RleStream_Unpack(&rle.base, unpacked, 15360, 1, 1024))
		return FALSE;
	return FAIL_DecodeCin(self, unpacked, 16384);
}

static cibool FAIL_DecodeChr(FAIL *self, unsigned char const *content, int contentLength)
{
	return contentLength == 3072 && FAIL_DecodeBlazingPaddlesVectors(self, content, contentLength, 28672);
}

static cibool FAIL_DecodeCin(FAIL *self, unsigned char const *content, int contentLength)
{
	int height;
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	switch (contentLength) {
	case 15360:
		FAIL_SetGr15DefaultColors(self);
		height = 192;
		break;
	case 16004:
		FAIL_SetBakPF012(self, content, 16000, 1);
		height = 200;
		break;
	case 16384:
		height = 192;
		break;
	default:
		return FALSE;
	}
	FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < height; y++) {
			if (contentLength == 16384)
				FAIL_SetBakPF012(self, content, 15360 + y, 256);
			FAIL_DecodeAtari8Gr15(self, content, y * 40, 40, (y & 1) == 0 ? frame1 : frame2, y * 320, 320, 1);
		}
	}
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 40 * height + 40, 80, frame1, 1);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 40 * height, 80, frame2, 0);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeCpr(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[7680];
	unsigned char frame[61440];
	if (contentLength < 2)
		return FALSE;
	if (!KoalaStream_UnpackKoala(content[0], content, 1, contentLength, unpacked, 7680))
		return FALSE;
	self->gtiaColors[6] = 12;
	self->gtiaColors[5] = 0;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE1X1);
	FAIL_DecodeAtari8Gr8(self, unpacked, 0, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeCpt(FAIL *self, unsigned char const *content, int contentLength)
{
	int bitplanes;
	unsigned char unpacked[32000];
	unsigned char isFilled[16000];
	int contentOffset;
	if (contentLength < 40 || content[32] != 0 || content[33] > 2)
		return FALSE;
	bitplanes = 4 >> content[33];
	memset(isFilled, 0, sizeof(isFilled));
	contentOffset = 34;
	for (;;) {
		int nextContentOffset = contentOffset + 4 + bitplanes * 2;
		int repeatCount;
		int offset;
		if (nextContentOffset > contentLength)
			return FALSE;
		repeatCount = (content[contentOffset] << 8) | content[contentOffset + 1];
		if (repeatCount == 65535) {
			contentOffset = nextContentOffset;
			break;
		}
		offset = ((content[contentOffset + 2] << 8) | content[contentOffset + 3]) * bitplanes;
		do {
			if (offset >= 16000)
				return FALSE;
			{
				int bitplane;
				for (bitplane = 0; bitplane < bitplanes; bitplane++) {
					unpacked[offset * 2] = content[contentOffset + 4 + bitplane * 2];
					unpacked[offset * 2 + 1] = content[contentOffset + 4 + bitplane * 2 + 1];
					isFilled[offset++] = 1;
				}
			}
		}
		while (--repeatCount >= 0);
		contentOffset = nextContentOffset;
	}
	{
		int offset;
		for (offset = 0; offset < 16000; offset++) {
			if (isFilled[offset] == 0) {
				if (contentOffset + 1 >= contentLength)
					return FALSE;
				unpacked[offset * 2] = content[contentOffset++];
				unpacked[offset * 2 + 1] = content[contentOffset++];
			}
		}
	}
	return FAIL_DecodeSt(self, unpacked, 0, content, 0, content[33]);
}

static cibool FAIL_DecodeDel(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[96000];
	if (!CaStream_UnpackDel(content, contentLength, unpacked, 2))
		return FALSE;
	return FAIL_DecodePi4(self, unpacked, 77824);
}

static cibool FAIL_DecodeDgc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[64000];
	int contentOffset;
	int valueBytes;
	int repeatCount;
	if (contentLength < 1042 || content[0] != 68 || content[1] != 71 || content[2] != 67 || content[3] > 3 || content[4] != 1 || content[5] != 64 || content[6] != 0 || content[7] != 200)
		return FALSE;
	if (content[3] == 0) {
		if (contentLength != 65034)
			return FALSE;
		FAIL_DecodeFalconPalette320(self, content, 1034, 10, 200);
		return TRUE;
	}
	contentOffset = 1038;
	valueBytes = 1 << (content[3] - 1);
	repeatCount = 0;
	{
		int bitplane;
		for (bitplane = 0; bitplane < 16; bitplane += 2) {
			{
				int unpackedOffset;
				for (unpackedOffset = bitplane; unpackedOffset < 64000; unpackedOffset += 16) {
					{
						int x;
						for (x = 0; x < 2; x++) {
							if (repeatCount == 0) {
								int nextContentOffset = contentOffset + content[3] * 2;
								if (nextContentOffset > contentLength)
									return FALSE;
								switch (content[3]) {
								case 1:
									repeatCount = content[contentOffset] + 1;
									break;
								case 2:
									repeatCount = ((content[contentOffset] << 8) + content[contentOffset + 1] + 1) << 1;
									break;
								case 3:
									repeatCount = ((content[contentOffset] << 8) + content[contentOffset + 1] + 1) << 2;
									break;
								}
								contentOffset = nextContentOffset;
							}
							repeatCount--;
							unpacked[unpackedOffset + x] = content[contentOffset - valueBytes + (~repeatCount & (valueBytes - 1))];
						}
					}
				}
			}
		}
	}
	FAIL_SetFalconPalette(self, content, 10);
	FAIL_SetSize(self, 320, 200, FAILResolution_FALCON1X1);
	FAIL_DecodeBitplanes(self, unpacked, 0, 8, 0, 64000);
	return TRUE;
}

static cibool FAIL_DecodeDgu(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 65032 || content[0] != 68 || content[1] != 71 || content[2] != 85 || content[3] != 1 || content[4] != 1 || content[5] != 64 || content[6] != 0 || content[7] != 200)
		return FALSE;
	FAIL_DecodeFalconPalette320(self, content, 1032, 8, 200);
	return TRUE;
}

static cibool FAIL_DecodeDin(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char screen2[7680];
	unsigned char frame2[61440];
	if (contentLength != 17351 || content[0] != 3)
		return FALSE;
	FAIL_SetBakPF0123(self, content, 2);
	self->gtiaColors[8] = content[1] & 254;
	FAIL_DecodeIce(self, content, 1031, frame1, screen2);
	FAIL_SetPF21(self, content, 1);
	FAIL_DecodeAtari8Gr8(self, screen2, 0, frame2);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeDlm(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char characters[176];
	unsigned char frame[11264];
	if (contentLength != 256)
		return FALSE;
	{
		int y;
		for (y = 0; y < 16; y++)
			{
				int x;
				for (x = 0; x < 11; x++)
					characters[y * 11 + x] = FAIL_ToAtari8Char(content[y * 16 + 5 + x]);
			}
	}
	FAIL_SetSize(self, 88, 128, FAILResolution_XE1X1);
	FAIL_DecodeAtari8Gr0(self, characters, 11, CiBinaryResource_atari8_fnt, 0, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeDoo(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 32000)
		return FALSE;
	FAIL_DecodeBlackAndWhite(self, content, 0, 640, 400, FAILResolution_ST1X1);
	return TRUE;
}

static cibool FAIL_DecodeDph(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char *unpacked = (unsigned char *) malloc(320000 * sizeof(unsigned char ));
	if (!CaStream_UnpackDel(content, contentLength, unpacked, 10)) {
		free(unpacked);
		return FALSE;
	}
	FAIL_SetFalconPalette(self, unpacked, 0);
	FAIL_SetSize(self, 640, 480, FAILResolution_FALCON1X1);
	{
		int y;
		for (y = 0; y < 240; y++) {
			FAIL_DecodeBitplanes(self, unpacked, 1024 + y * 320, 8, y * 640, 320);
			FAIL_DecodeBitplanes(self, unpacked, 77824 + y * 320, 8, y * 640 + 320, 320);
			FAIL_DecodeBitplanes(self, unpacked, 154624 + y * 320, 8, (240 + y) * 640, 320);
			FAIL_DecodeBitplanes(self, unpacked, 231424 + y * 320, 8, (240 + y) * 640 + 320, 320);
		}
	}
	free(unpacked);
	return TRUE;
}

static cibool FAIL_DecodeDrg(FAIL *self, unsigned char const *content, int contentLength)
{
	return contentLength == 6400 && FAIL_DecodeGr8(self, content, contentLength);
}

static void FAIL_DecodeFalconPalette320(FAIL *self, unsigned char const *content, int bitplanesOffset, int paletteOffset, int height)
{
	FAIL_SetFalconPalette(self, content, paletteOffset);
	FAIL_SetSize(self, 320, height, FAILResolution_FALCON1X1);
	FAIL_DecodeBitplanes(self, content, bitplanesOffset, 8, 0, 320 * height);
}

static cibool FAIL_DecodeFalconTrueColor(FAIL *self, unsigned char const *content, int contentLength, int contentOffset, int width, int height)
{
	int pixelsCount = width * height;
	if (contentOffset + pixelsCount * 2 != contentLength)
		return FALSE;
	FAIL_SetSize(self, width, height, FAILResolution_FALCON1X1);
	{
		int i;
		for (i = 0; i < pixelsCount; i++) {
			int rg = content[contentOffset + i * 2];
			int gb = content[contentOffset + i * 2 + 1];
			int r = (rg & 248) | (rg >> 5);
			int g = ((rg & 7) << 3) | (gb >> 5);
			int b;
			g = (g << 2) | (g >> 4);
			b = gb & 31;
			b = (b << 3) | (b >> 2);
			self->pixels[i] = (r << 16) | (g << 8) | b;
		}
	}
	return TRUE;
}

static cibool FAIL_DecodeFalconTrueColorVariable(FAIL *self, unsigned char const *content, int contentLength, int widthOffset, int dataOffset)
{
	int width = (content[widthOffset] << 8) | content[widthOffset + 1];
	int height = (content[widthOffset + 2] << 8) | content[widthOffset + 3];
	if (width > 640 || height > 560)
		return FALSE;
	return FAIL_DecodeFalconTrueColor(self, content, contentLength, dataOffset, width, height);
}

static cibool FAIL_DecodeFnt(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	unsigned char characters[128];
	switch (contentLength) {
	case 1024:
	case 1025:
	case 1026:
		contentOffset = 0;
		break;
	case 1030:
		if (FAIL_ParseAtari8ExecutableHeader(content, 0) != 1024)
			return FALSE;
		contentOffset = 6;
		break;
	default:
		return FALSE;
	}
	{
		int i;
		for (i = 0; i < 128; i++)
			characters[i] = i;
	}
	return FAIL_DecodeAtari8Font(self, characters, content, contentOffset);
}

static cibool FAIL_DecodeFtc(FAIL *self, unsigned char const *content, int contentLength)
{
	return FAIL_DecodeFalconTrueColor(self, content, contentLength, 0, 384, 240);
}

static cibool FAIL_DecodeFwa(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	int dlOffset;
	int dliOffset;
	if (contentLength < 7960 || content[0] != 254 || content[1] != 254 || content[6] != 112 || content[7] != 112 || content[8] != 112 || content[11] != 80 || content[115] != 96 || content[205] != 65 || 7960 + content[7958] + (content[7959] << 8) != contentLength)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	FAIL_SetBakPF012(self, content, 2, 1);
	dlOffset = 9;
	dliOffset = 7960;
	{
		int y;
		for (y = 0; y < 192; y++) {
			int dlInstr;
			FAIL_DecodeAtari8Gr15(self, content, 262 + 40 * y + (y >= 102 ? 16 : 0), 40, frame, y * 320, 320, 1);
			dlInstr = content[dlOffset];
			if (dlOffset == 9 || dlOffset == 113) {
				if ((dlInstr & 127) != 78 || content[dlOffset + 1] != 0)
					return FALSE;
				dlOffset += 3;
			}
			else {
				if ((dlInstr & 127) != 14)
					return FALSE;
				dlOffset++;
			}
			if (dlInstr >= 128) {
				unsigned char a;
				if (dliOffset + 14 > contentLength || content[dliOffset] != 72 || content[dliOffset + 1] != 138 || content[dliOffset + 2] != 72 || content[dliOffset + 3] != 169 || content[dliOffset + 5] != 141 || content[dliOffset + 6] != 10 || content[dliOffset + 7] != 212)
					return FALSE;
				a = content[dliOffset + 4];
				dliOffset += 8;
				while (content[dliOffset] != 32) {
					switch (content[dliOffset]) {
						int lo;
					case 169:
						a = content[dliOffset + 1];
						dliOffset += 2;
						break;
					case 141:
						if (content[dliOffset + 2] != 208)
							return FALSE;
						lo = content[dliOffset + 1];
						switch (lo) {
						case 22:
						case 23:
						case 24:
						case 26:
							self->gtiaColors[lo - 18] = a & 254;
							break;
						default:
							return FALSE;
						}
						dliOffset += 3;
						break;
					default:
						return FALSE;
					}
					if (dliOffset + 3 > contentLength)
						return FALSE;
				}
				if (content[dliOffset + 1] != 202 || content[dliOffset + 2] != 6)
					return FALSE;
				dliOffset += 3;
			}
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeG09(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[122880];
	switch (contentLength) {
	case 7680:
		return FAIL_DecodeGr9(self, content, contentLength);
	case 15360:
		break;
	default:
		return FALSE;
	}
	FAIL_SetSize(self, 640, 192, FAILResolution_XE4X1);
	self->gtiaColors[8] = 0;
	FAIL_DecodeAtari8Gr9(self, content, 0, 40, frame, 0, 640, 320, 192);
	FAIL_DecodeAtari8Gr9(self, content, 7680, 40, frame, 320, 640, 320, 192);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeG10(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	unsigned char frame[76800];
	if (!FAIL_SetAtari8RawSize(self, content, contentLength, FAILResolution_XE4X1))
		return FALSE;
	contentOffset = FAIL_GetAtari8ExecutableOffset(content, contentLength);
	if ((contentLength - contentOffset) % 40 != 9)
		return FALSE;
	self->gtiaLeftSkip = 2;
	FAIL_SetGtiaColors(self, content, contentLength - 9);
	FAIL_DecodeAtari8Gr10(self, content, contentOffset, frame, 0, 320, self->height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeG11(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	unsigned char frame[76800];
	if (!FAIL_SetAtari8RawSize(self, content, contentLength, FAILResolution_XE4X1))
		return FALSE;
	self->gtiaColors[8] = 6;
	contentOffset = FAIL_GetAtari8ExecutableOffset(content, contentLength);
	FAIL_DecodeAtari8Gr11(self, content, contentOffset, frame, 0, 320, self->height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeGfb(FAIL *self, unsigned char const *content, int contentLength)
{
	int bitplanes;
	int width;
	int height;
	int bitmapLength;
	if (contentLength < 20 || !FAIL_IsStringAt(content, 0, "GF25"))
		return FALSE;
	switch (FAIL_Get32BigEndian(content, 4)) {
	case 2:
		bitplanes = 1;
		break;
	case 4:
		bitplanes = 2;
		break;
	case 16:
		bitplanes = 4;
		break;
	case 256:
		bitplanes = 8;
		break;
	default:
		return FALSE;
	}
	width = FAIL_Get32BigEndian(content, 8);
	if (width <= 0 || width > 640 || (width & 15) != 0)
		return FALSE;
	height = FAIL_Get32BigEndian(content, 12);
	if (height <= 0 || height > 560)
		return FALSE;
	bitmapLength = FAIL_Get32BigEndian(content, 16);
	if (1556 + bitmapLength != contentLength || bitmapLength != (width >> 3) * bitplanes * height)
		return FALSE;
	{
		int i;
		for (i = 0; i < 1 << bitplanes; i++) {
			int j;
			int rgb;
			switch (i) {
			case 1:
				j = (1 << bitplanes) - 1;
				break;
			case 2:
				j = 1;
				break;
			case 3:
				j = 2;
				break;
			case 5:
				j = 6;
				break;
			case 6:
				j = 3;
				break;
			case 7:
				j = 5;
				break;
			case 8:
				j = 7;
				break;
			case 9:
				j = 8;
				break;
			case 10:
				j = 9;
				break;
			case 11:
				j = 10;
				break;
			case 13:
				j = 14;
				break;
			case 14:
				j = 11;
				break;
			case 15:
				j = 13;
				break;
			case 255:
				j = 15;
				break;
			default:
				j = i;
				break;
			}
			rgb = 0;
			{
				int k;
				for (k = 0; k < 3; k++) {
					int offset = 20 + bitmapLength + (i * 3 + k) * 2;
					int c = (content[offset] << 8) | content[offset + 1];
					if (c > 1000)
						return FALSE;
					rgb = (rgb << 8) | c * 255 / 1000;
				}
			}
			self->atari16Palette[j] = rgb;
		}
	}
	FAIL_SetSizeStOrFalcon(self, width, height, bitplanes);
	FAIL_DecodeBitplanes(self, content, 20, bitplanes, 0, width * height);
	return TRUE;
}

static cibool FAIL_DecodeGhg(FAIL *self, unsigned char const *content, int contentLength)
{
	int width;
	int height;
	unsigned char frame[64000];
	if (contentLength < 4)
		return FALSE;
	width = ((content[0] | (content[1] << 8)) + 7) & ~7;
	height = content[2];
	if (width == 0 || width > 320 || height == 0 || height > 200)
		return FALSE;
	FAIL_SetSize(self, width, height, FAILResolution_XE1X1);
	self->gtiaColors[6] = 12;
	self->gtiaColors[5] = 2;
	FAIL_DecodeAtari8Gr8(self, content, 3, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeGod(FAIL *self, unsigned char const *content, int contentLength)
{
	return contentLength > 6 && FAIL_DecodeFalconTrueColorVariable(self, content, contentLength, 2, 6);
}

static cibool FAIL_DecodeGr15Blend(FAIL *self, unsigned char const *content, int bitmapOffset, int colorsOffset, int height)
{
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
	FAIL_SetPF012Bak(self, content, colorsOffset);
	FAIL_DecodeAtari8Gr15(self, content, bitmapOffset, 80, frame1, 0, 640, height >> 1);
	FAIL_SetPF012Bak(self, content, colorsOffset + 4);
	FAIL_DecodeAtari8Gr15(self, content, bitmapOffset + 40, 80, frame1, 320, 640, height >> 1);
	FAIL_DecodeAtari8Gr15(self, content, bitmapOffset + height * 40, 80, frame2, 0, 640, height >> 1);
	FAIL_SetPF012Bak(self, content, colorsOffset);
	FAIL_DecodeAtari8Gr15(self, content, bitmapOffset + height * 40 + 40, 80, frame2, 320, 640, height >> 1);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeGr7(FAIL *self, unsigned char const *content, int contentOffset, int contentSize)
{
	int height;
	unsigned char frame[76800];
	if (contentSize > 4804 || contentSize % 40 != 4)
		return FALSE;
	height = contentSize / 40;
	FAIL_SetSize(self, 320, height * 2, FAILResolution_XE2X2);
	FAIL_SetBakPF012(self, content, contentOffset + contentSize - 4, 1);
	FAIL_DecodeAtari8Gr7(self, content, contentOffset, frame, 0, height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeGr8(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	unsigned char frame[76800];
	if (!FAIL_SetAtari8RawSize(self, content, contentLength, FAILResolution_XE1X1))
		return FALSE;
	self->gtiaColors[6] = 0;
	self->gtiaColors[5] = 14;
	contentOffset = FAIL_GetAtari8ExecutableOffset(content, contentLength);
	FAIL_DecodeAtari8Gr8(self, content, contentOffset, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeGr9(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	unsigned char frame[76800];
	if (!FAIL_SetAtari8RawSize(self, content, contentLength, FAILResolution_XE4X1))
		return FALSE;
	self->gtiaColors[8] = 0;
	contentOffset = FAIL_GetAtari8ExecutableOffset(content, contentLength);
	FAIL_DecodeAtari8Gr9(self, content, contentOffset, 40, frame, 0, 320, 320, self->height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static void FAIL_DecodeHam(FAIL *self, unsigned char const *unpacked, int width, int height, int bitplanes)
{
	int holdBits = bitplanes > 6 ? 6 : 4;
	int i = 0;
	{
		int y;
		for (y = 0; y < height; y++) {
			int rgb = self->atari16Palette[0];
			{
				int x;
				for (x = 0; x < width; x++) {
					int offset = ((i >> 3) & ~1) * bitplanes + ((i >> 3) & 1);
					int bit = ~i & 7;
					int c = 0;
					{
						int bitplane;
						for (bitplane = bitplanes; --bitplane >= 0;)
							c = (c << 1) | ((unpacked[offset + (bitplane << 1)] >> bit) & 1);
					}
					switch (c >> holdBits) {
					case 0:
						rgb = self->atari16Palette[c];
						break;
					case 1:
						c = (c << (8 - holdBits)) & 255;
						c |= c >> holdBits;
						rgb = (rgb & 16776960) | c;
						break;
					case 2:
						c = (c << (8 - holdBits)) & 255;
						c |= c >> holdBits;
						rgb = (rgb & 65535) | (c << 16);
						break;
					case 3:
						c = (c << (8 - holdBits)) & 255;
						c |= c >> holdBits;
						rgb = (rgb & 16711935) | (c << 8);
						break;
					}
					self->pixels[i++] = rgb;
				}
			}
		}
	}
}

static cibool FAIL_DecodeHip(FAIL *self, unsigned char const *content, int contentLength)
{
	static const unsigned char gr10Colors[9] = { 0, 0, 2, 4, 6, 8, 10, 12, 14 };
	unsigned char frame1[76800];
	unsigned char frame2[76800];
	int frameLength;
	if (contentLength < 80)
		return FALSE;
	frameLength = FAIL_ParseAtari8ExecutableHeader(content, 0);
	if (frameLength > 0 && frameLength % 40 == 0 && 12 + frameLength * 2 == contentLength && FAIL_ParseAtari8ExecutableHeader(content, 6 + frameLength) == frameLength) {
		int height = frameLength / 40;
		if (height > 240)
			return FALSE;
		FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
		self->gtiaLeftSkip = 1;
		FAIL_SetGtiaColors(self, gr10Colors, 0);
		FAIL_DecodeAtari8Gr10(self, content, 6, frame1, 0, 320, height);
		self->gtiaColors[8] = 0;
		FAIL_DecodeAtari8Gr9(self, content, 12 + frameLength, 40, frame2, 0, 320, 320, height);
	}
	else {
		int height = contentLength / 80;
		if (height > 240)
			return FALSE;
		FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
		self->gtiaLeftSkip = 1;
		self->gtiaColors[8] = 0;
		FAIL_DecodeAtari8Gr9(self, content, 0, 40, frame1, 0, 320, 320, height);
		if (contentLength % 80 == 9)
			FAIL_SetGtiaColors(self, content, contentLength - 9);
		else
			FAIL_SetGtiaColors(self, gr10Colors, 0);
		FAIL_DecodeAtari8Gr10(self, content, height * 40, frame2, 0, 320, height);
	}
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeHpm(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[7684];
	HpmStream rle;
	HpmStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 0;
	rle.base.base.contentLength = contentLength;
	if (!RleStream_Unpack(&rle.base, unpacked, 0, 1, 7680))
		return FALSE;
	switch (RleStream_ReadByte(&rle.base)) {
	case 52:
	case 53:
		unpacked[7680] = 0;
		unpacked[7681] = 52;
		unpacked[7682] = contentLength == 3494 ? 56 : 200;
		unpacked[7683] = contentLength == 3494 ? 60 : 124;
		break;
	case 81:
		unpacked[7680] = 164;
		unpacked[7681] = 81;
		unpacked[7682] = 185;
		unpacked[7683] = 124;
		break;
	case 228:
		unpacked[7680] = 0;
		unpacked[7681] = 228;
		unpacked[7682] = 200;
		unpacked[7683] = 190;
		break;
	case 4:
		unpacked[7680] = 6;
		unpacked[7681] = 4;
		unpacked[7682] = 0;
		unpacked[7683] = 10;
		break;
	case 48:
		unpacked[7680] = 14;
		unpacked[7681] = 48;
		unpacked[7682] = 199;
		unpacked[7683] = 123;
		break;
	case 116:
		unpacked[7680] = 0;
		unpacked[7681] = 116;
		unpacked[7682] = 88;
		unpacked[7683] = 126;
		break;
	default:
		unpacked[7680] = 0;
		unpacked[7681] = 4;
		unpacked[7682] = 8;
		unpacked[7683] = 12;
		break;
	}
	return FAIL_DecodeMic(self, unpacked, 7684);
}

static cibool FAIL_DecodeHr(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61184];
	unsigned char frame2[61184];
	if (contentLength != 16384)
		return FALSE;
	FAIL_SetSize(self, 256, 239, FAILResolution_XE1X1);
	self->gtiaColors[6] = 0;
	self->gtiaColors[5] = 14;
	FAIL_DecodeAtari8Gr8(self, content, 0, frame1);
	FAIL_DecodeAtari8Gr8(self, content, 8192, frame2);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeHr2(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	if (contentLength != 16006)
		return FALSE;
	FAIL_SetSize(self, 320, 200, FAILResolution_XE1X1);
	FAIL_SetPF21(self, content, 16000);
	FAIL_DecodeAtari8Gr8(self, content, 0, frame1);
	FAIL_SetBakPF012(self, content, 16002, 1);
	FAIL_DecodeAtari8Gr15(self, content, 8000, 40, frame2, 0, 320, 200);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static void FAIL_DecodeIce(FAIL *self, unsigned char const *content, int contentOffset, unsigned char *frame1, unsigned char *screen2)
{
	int screen2Offset;
	FAIL_SetSize(self, 320, 192, contentOffset >= 16 ? FAILResolution_XE1X1 : FAILResolution_XE2X1);
	screen2Offset = 0;
	{
		int row;
		for (row = 0; row < 24; row++) {
			int charactersOffset = (contentOffset & 15) + 16384 + row * 40;
			int fontOffset = contentOffset + (row / 3 << 11);
			FAIL_DecodeAtari8Gr12Line(self, content, charactersOffset, content, fontOffset, frame1, row * 2560);
			{
				int y;
				for (y = 0; y < 8; y++) {
					{
						int x;
						for (x = 0; x < 40; x++) {
							int ch = content[charactersOffset + x] & 127;
							screen2[screen2Offset++] = content[(fontOffset ^ 1024) + (ch << 3) + y];
						}
					}
				}
			}
		}
	}
}

static cibool FAIL_DecodeIff(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentOffset;
	int width;
	int height;
	int bitplanes;
	cibool hasMask;
	int compression;
	int colors;
	int camg;
	if (contentLength < 56 || !FAIL_IsStringAt(content, 0, "FORM"))
		return FALSE;
	contentOffset = 8;
	if (FAIL_IsStringAt(content, 8, "DPSTDPAH") && FAIL_Get32BigEndian(content, 16) == 24 && FAIL_IsStringAt(content, 44, "FORM"))
		contentOffset = 52;
	if (!FAIL_IsStringAt(content, contentOffset, "ILBM") && !FAIL_IsStringAt(content, contentOffset, "ACBM"))
		return FALSE;
	contentOffset += 4;
	width = 0;
	height = 0;
	bitplanes = 0;
	hasMask = FALSE;
	compression = 0;
	colors = 0;
	camg = 0;
	while (contentOffset + 7 < contentLength) {
		int chunkLength = FAIL_Get32BigEndian(content, contentOffset + 4);
		if (contentOffset + 8 + chunkLength > contentLength)
			break;
		if (FAIL_IsStringAt(content, contentOffset, "BMHD") && chunkLength >= 11) {
			width = (content[contentOffset + 8] << 8) | content[contentOffset + 9];
			height = (content[contentOffset + 10] << 8) | content[contentOffset + 11];
			bitplanes = content[contentOffset + 16];
			hasMask = content[contentOffset + 17] == 1;
			compression = content[contentOffset + 18];
			if (width == 0 || width > 640 || height == 0 || height > 560 || bitplanes == 0 || (bitplanes > 8 && bitplanes != 24 && bitplanes != 32) || compression > 2)
				return FALSE;
			width = (width + 15) & ~15;
		}
		else if (FAIL_IsStringAt(content, contentOffset, "CMAP")) {
			int c;
			colors = chunkLength / 3;
			if (colors > 256)
				return FALSE;
			for (c = 0; c < colors; c++) {
				int offset = contentOffset + 8 + c * 3;
				self->atari16Palette[c] = (content[offset] << 16) | (content[offset + 1] << 8) | content[offset + 2];
			}
			for (; c < 256; c++)
				self->atari16Palette[c] = 0;
		}
		else if (FAIL_IsStringAt(content, contentOffset, "CAMG") && chunkLength >= 4)
			camg = FAIL_Get32BigEndian(content, contentOffset + 8);
		else if (FAIL_IsStringAt(content, contentOffset, "BODY")) {
			int bytesPerLine;
			unsigned char *unpacked;
			if (width == 0)
				return FALSE;
			bytesPerLine = (width >> 3) * bitplanes;
			unpacked = (unsigned char *) malloc(bytesPerLine * height * sizeof(unsigned char ));
			if (compression == 2) {
				VdatStream rle;
				VdatStream_Construct(&rle, NULL);
				rle.base.base.base.base.content = content;
				rle.base.base.base.base.contentOffset = contentOffset + 8;
				{
					int bitplane;
					for (bitplane = 0; bitplane < bitplanes; bitplane++) {
						int nextContentOffset;
						if (rle.base.base.base.base.contentOffset + 14 > contentLength || !FAIL_IsStringAt(content, rle.base.base.base.base.contentOffset, "VDAT"))
							return FALSE;
						nextContentOffset = rle.base.base.base.base.contentOffset + 8 + FAIL_Get32BigEndian(content, rle.base.base.base.base.contentOffset + 4);
						if (nextContentOffset > contentOffset + 8 + chunkLength)
							return FALSE;
						rle.base.valueOffset = rle.base.base.base.base.contentLength = rle.base.base.base.base.contentOffset + 8 + (content[rle.base.base.base.base.contentOffset + 8] << 8) + content[rle.base.base.base.base.contentOffset + 9];
						rle.base.valueLength = nextContentOffset;
						rle.base.base.base.base.contentOffset += 10;
						{
							int x;
							for (x = bitplane << 1; x < bytesPerLine; x += bitplanes << 1) {
								int unpackedOffset = x;
								{
									int y;
									for (y = 0; y < height; y++) {
										int b = RleStream_ReadRle(&rle.base.base.base);
										if (b < 0)
											return FALSE;
										unpacked[unpackedOffset] = b >> 8;
										unpacked[unpackedOffset + 1] = (unsigned char) b;
										unpackedOffset += bytesPerLine;
									}
								}
							}
						}
						rle.base.base.base.base.contentOffset = nextContentOffset;
					}
				}
			}
			else {
				PackBitsStream rle;
				PackBitsStream_Construct(&rle, NULL);
				rle.base.base.content = content;
				rle.base.base.contentOffset = contentOffset + 8;
				rle.base.base.contentLength = contentOffset + 8 + chunkLength;
				{
					int y;
					for (y = 0; y < height; y++) {
						{
							int bitplane;
							for (bitplane = 0; bitplane < bitplanes; bitplane++) {
								{
									int w;
									for (w = bitplane << 1; w < bytesPerLine; w += bitplanes << 1) {
										{
											int x;
											for (x = 0; x < 2; x++) {
												int b = compression == 0 ? RleStream_ReadByte(&rle.base) : RleStream_ReadRle(&rle.base);
												if (b < 0)
													return FALSE;
												unpacked[y * bytesPerLine + w + x] = b;
											}
										}
									}
								}
							}
						}
						if (hasMask) {
							{
								int x;
								for (x = 0; x < width; x += 8) {
									int b = compression == 0 ? RleStream_ReadByte(&rle.base) : RleStream_ReadRle(&rle.base);
									if (b < 0)
										return FALSE;
								}
							}
						}
					}
				}
			}
			FAIL_DecodeIffUnpacked(self, unpacked, width, height, bitplanes, colors, camg);
			return TRUE;
		}
		else if (FAIL_IsStringAt(content, contentOffset, "ABIT")) {
			unsigned char *unpacked;
			if (width == 0 || compression != 0 || chunkLength != (width >> 3) * height * bitplanes)
				return FALSE;
			contentOffset += 8;
			unpacked = (unsigned char *) malloc(chunkLength * sizeof(unsigned char ));
			{
				int bitplane;
				for (bitplane = 0; bitplane < bitplanes; bitplane++) {
					{
						int unpackedOffset;
						for (unpackedOffset = bitplane << 1; unpackedOffset < chunkLength; unpackedOffset += bitplanes << 1) {
							{
								int x;
								for (x = 0; x < 2; x++)
									unpacked[unpackedOffset + x] = content[contentOffset++];
							}
						}
					}
				}
			}
			FAIL_DecodeIffUnpacked(self, unpacked, width, height, bitplanes, colors, camg);
			return TRUE;
		}
		contentOffset += 8 + ((chunkLength + 1) & ~1);
	}
	return FALSE;
}

static void FAIL_DecodeIffUnpacked(FAIL *self, unsigned char *unpacked, int width, int height, int bitplanes, int colors, int camg)
{
	int pixelsCount = width * height;
	if (camg != 0)
		FAIL_SetSize(self, width, height, FAILResolution_AMIGA1X1);
	else
		FAIL_SetSizeStOrFalcon(self, width, height, bitplanes);
	if (bitplanes <= 8) {
		if (colors == 0) {
			colors = 1 << bitplanes;
			{
				int c;
				for (c = 0; c < colors; c++)
					self->atari16Palette[c] = c * 255 / colors * 65793;
			}
		}
		else if ((camg & 2176) == 128 && bitplanes == 6 && colors < 64) {
			{
				int c;
				for (c = 0; c < 32; c++)
					self->atari16Palette[32 + c] = (self->atari16Palette[c] >> 1) & 8355711;
			}
		}
		if ((camg & 2048) != 0) {
			FAIL_DecodeHam(self, unpacked, width, height, bitplanes);
		}
		else {
			FAIL_DecodeBitplanes(self, unpacked, 0, bitplanes, 0, pixelsCount);
		}
	}
	else {
		{
			int i;
			for (i = 0; i < pixelsCount; i++) {
				int offset = ((i >> 3) & ~1) * bitplanes + ((i >> 3) & 1);
				int bit = ~i & 7;
				int c = 0;
				{
					int bitplane;
					for (bitplane = 24; --bitplane >= 0;)
						c = (c << 1) | ((unpacked[offset + (bitplane << 1)] >> bit) & 1);
				}
				self->pixels[i] = ((c & 255) << 16) | (c & 65280) | (c >> 16);
			}
		}
	}
	free(unpacked);
}

static cibool FAIL_DecodeIge(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[24576];
	unsigned char frame2[24576];
	if (contentLength != 6160 || content[0] != 255 || content[1] != 255 || content[2] != 246 || content[3] != 163 || content[4] != 255 || content[5] != 187 || content[6] != 255 || content[7] != 95)
		return FALSE;
	FAIL_SetSize(self, 256, 96, FAILResolution_XE2X1);
	FAIL_SetBakPF012(self, content, 8, 1);
	FAIL_DecodeAtari8Gr15(self, content, 16, 32, frame1, 0, 256, 96);
	FAIL_SetBakPF012(self, content, 12, 1);
	FAIL_DecodeAtari8Gr15(self, content, 3088, 32, frame2, 0, 256, 96);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeImn(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char screen2[7680];
	unsigned char frame2[61440];
	if (contentLength != 17350 || content[0] != 1)
		return FALSE;
	FAIL_SetBakPF0123(self, content, 1);
	FAIL_DecodeIce(self, content, 6, frame1, screen2);
	FAIL_DecodeAtari8Gr9(self, screen2, 0, 40, frame2, 0, 320, 320, 192);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeInp(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	if (contentLength < 16004)
		return FALSE;
	FAIL_SetSize(self, 320, 200, FAILResolution_XE2X1);
	FAIL_SetBakPF012(self, content, 16000, 1);
	FAIL_DecodeAtari8Gr15(self, content, 0, 40, frame1, 0, 320, 200);
	FAIL_DecodeAtari8Gr15(self, content, 8000, 40, frame2, 0, 320, 200);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeInt(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentStride;
	int height;
	int width;
	unsigned char frame1[76480];
	unsigned char frame2[76480];
	if (contentLength < 18 || !FAIL_IsStringAt(content, 0, "INT95a") || content[8] != 15 || content[9] != 43)
		return FALSE;
	contentStride = content[6];
	height = content[7];
	if (contentStride == 0 || contentStride > 320 || height == 0 || height > 239 || 18 + contentStride * height * 2 != contentLength)
		return FALSE;
	width = contentStride << 3;
	FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
	FAIL_SetBakPF012(self, content, 10, 1);
	FAIL_DecodeAtari8Gr15(self, content, 18, contentStride, frame1, 0, width, height);
	FAIL_SetBakPF012(self, content, 14, 1);
	FAIL_DecodeAtari8Gr15(self, content, 18 + contentStride * height, contentStride, frame2, 0, width, height);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeIp2(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char screen2[7680];
	unsigned char frame2[61440];
	if (contentLength != 17358 || content[0] != 1)
		return FALSE;
	self->gtiaColors[8] = content[1] & 254;
	self->gtiaColors[4] = content[5] & 254;
	self->gtiaColors[5] = content[7] & 254;
	self->gtiaColors[6] = content[9] & 254;
	self->gtiaColors[7] = content[11] & 254;
	FAIL_DecodeIce(self, content, 14, frame1, screen2);
	self->gtiaLeftSkip = 2;
	{
		int i;
		for (i = 0; i < 4; i++) {
			self->gtiaColors[i] = content[1 + i] & 254;
			FAIL_SetGtiaColor(self, 4 + i, content[6 + i * 2]);
		}
	}
	FAIL_SetGtiaColor(self, 8, content[13]);
	FAIL_DecodeAtari8Gr10(self, screen2, 0, frame2, 0, 320, 192);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeIpc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char screen2[7680];
	unsigned char frame2[61440];
	if (contentLength != 17354 || content[0] != 1)
		return FALSE;
	FAIL_SetPF0123Bak(self, content, 5);
	self->gtiaColors[8] = content[1] & 254;
	FAIL_DecodeIce(self, content, 10, frame1, screen2);
	self->gtiaLeftSkip = 2;
	FAIL_SetGtiaColors(self, content, 1);
	FAIL_DecodeAtari8Gr10(self, screen2, 0, frame2, 0, 320, 192);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeIr2(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	if (contentLength != 18314 || content[0] != 1)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	self->gtiaColors[8] = content[1] & 254;
	FAIL_SetPF0123Even(self, content, 2);
	FAIL_DecodeAtari8Gr12(self, content, 16394, 10, frame1);
	FAIL_SetPF0123Even(self, content, 3);
	FAIL_DecodeAtari8Gr12(self, content, 17354, 1034, frame2);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeIrg(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	if (contentLength != 18310 || content[0] != 1)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	FAIL_SetBakPF0123(self, content, 1);
	FAIL_DecodeAtari8Gr12(self, content, 16390, 6, frame1);
	FAIL_DecodeAtari8Gr12(self, content, 17350, 1030, frame2);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeIst(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	if (contentLength != 17184)
		return FALSE;
	FAIL_SetSize(self, 320, 200, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 200; y++) {
			FAIL_SetBakPF012(self, content, 16384 + y, 200);
			FAIL_DecodeAtari8Gr15(self, content, 16 + y * 40, 0, frame1, y * 320, 320, 1);
			FAIL_DecodeAtari8Gr15(self, content, 8208 + y * 40, 0, frame2, y * 320, 320, 1);
		}
	}
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeJgp(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char characters[32];
	unsigned char frame[16384];
	if (contentLength != 2054 || FAIL_ParseAtari8ExecutableHeader(content, 0) != 2048)
		return FALSE;
	{
		int i;
		for (i = 0; i < 32; i++)
			characters[i] = i;
	}
	FAIL_SetGr15DefaultColors(self);
	FAIL_SetSize(self, 256, 64, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 8; y++)
			FAIL_DecodeAtari8Gr12Line(self, characters, 0, content, 6 + ((y & 6) << 7) + ((y & 1) << 10), frame, y << 11);
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMax(FAIL *self, unsigned char const *content, int contentLength)
{
	XlpStream rle;
	unsigned char unpacked[15360];
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	if (contentLength < 1732 || !FAIL_IsStringAt(content, 0, "XLPM"))
		return FALSE;
	XlpStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 1732;
	rle.base.base.contentLength = contentLength;
	if (!RleStream_Unpack(&rle.base, unpacked, 0, 40, 15360))
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 192; y++) {
			FAIL_SetBakPF012(self, content, 772 + y, 192);
			FAIL_DecodeAtari8Gr15(self, unpacked, y * 40, 40, frame1, y * 320, 320, 1);
			FAIL_SetBakPF012(self, content, 4 + y, 192);
			FAIL_DecodeAtari8Gr15(self, unpacked, 7680 + y * 40, 40, frame2, y * 320, 320, 1);
		}
	}
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeMbg(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[131072];
	if (contentLength != 16384)
		return FALSE;
	FAIL_SetSize(self, 512, 256, FAILResolution_XE1X1);
	self->gtiaColors[6] = 0;
	self->gtiaColors[5] = 14;
	FAIL_DecodeAtari8Gr8(self, content, 0, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMch(FAIL *self, unsigned char const *content, int contentLength)
{
	int width;
	int charactersStride;
	int charactersOffset;
	unsigned char frame[84480];
	switch (contentLength) {
	case 9840:
		width = 128;
		charactersStride = 32;
		charactersOffset = 0;
		break;
	case 12000:
		width = 160;
		charactersStride = 40;
		charactersOffset = 0;
		break;
	case 14160:
		width = 176;
		charactersStride = 48;
		charactersOffset = 3;
		break;
	default:
		return FALSE;
	}
	FAIL_SetSize(self, width * 2, 240, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 240; y++) {
			int colorsOffset = contentLength - 1200 + y;
			{
				int x;
				for (x = 0; x < width; x++) {
					int offset = (charactersOffset + (y >> 3) * charactersStride + (x >> 2)) * 9;
					int c = (content[offset + 1 + (y & 7)] >> (~x & 3) * 2) & 3;
					if (c == 3 && content[offset] >= 128)
						c = 4;
					offset = (y * width + x) * 2;
					frame[offset + 1] = frame[offset] = content[colorsOffset + c * 240] & 254;
				}
			}
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMcp(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 16008)
		return FALSE;
	return FAIL_DecodeGr15Blend(self, content, 0, 16000, 200);
}

static cibool FAIL_DecodeMcs(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	if (contentLength != 10185)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 192; y++) {
			int fontOffset = 9 + (y / 24 << 10);
			{
				int x;
				for (x = 0; x < 320; x++) {
					int ch = content[8201 + (y >> 3) * 40 + (x >> 3)];
					int c;
					switch ((content[fontOffset + ((ch & 127) << 3) + (y & 7)] >> (~x & 6)) & 3) {
						int pmgBit;
						int pmgOffset;
					case 0:
						c = x / 80;
						pmgBit = (x >> 3) % 10;
						if (pmgBit < 8) {
							pmgBit = 7 - pmgBit;
							pmgOffset = 9305 + (c << 7);
						}
						else {
							pmgBit = (c << 1) | (pmgBit ^ 9);
							pmgOffset = 9177;
						}
						if (((content[pmgOffset + (y >> 1)] >> pmgBit) & 1) == 0)
							c = 8;
						break;
					case 1:
						c = 4;
						break;
					case 2:
						c = 5;
						break;
					default:
						c = 6 + (ch >> 7);
						break;
					}
					frame[y * 320 + x] = content[c] & 254;
				}
			}
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMgp(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[61440];
	int rainbow;
	unsigned char bitmap[3840];
	if (contentLength != 3845)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE2X2);
	FAIL_SetPF0123Bak(self, content, 0);
	rainbow = content[5];
	memcpy(bitmap + 0, content + 6, 3839);
	bitmap[3839] = 0;
	{
		int y;
		for (y = 0; y < 96; y++) {
			if (rainbow < 4) {
				self->gtiaColors[rainbow == 0 ? 8 : 3 + rainbow] = (16 + y) & 254;
			}
			FAIL_DecodeAtari8Gr7(self, bitmap, y * 40, frame, y * 640, 1);
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMic(FAIL *self, unsigned char const *content, int contentLength)
{
	int height;
	unsigned char frame[76800];
	if (contentLength == 15872) {
		contentLength = 7680;
		FAIL_SetPF012Bak(self, content, 7680);
	}
	else {
		switch (contentLength % 40) {
		case 0:
		case 3:
			FAIL_SetGr15DefaultColors(self);
			break;
		case 4:
			FAIL_SetBakPF012(self, content, contentLength - 4, 1);
			break;
		case 5:
			FAIL_SetPF012Bak(self, content, contentLength - 5);
			break;
		default:
			return FALSE;
		}
	}
	height = contentLength / 40;
	if (height == 0 || height > 240)
		return FALSE;
	FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
	FAIL_DecodeAtari8Gr15(self, content, 0, 40, frame, 0, 320, height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeMis(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[960];
	if (contentLength != 61 && contentLength != 241)
		return FALSE;
	FAIL_SetSize(self, 4, 240, FAILResolution_XE2X1);
	{
		int y;
		for (y = 0; y < 240; y++) {
			int b = content[1 + (y >> 2)] >> ((~y & 3) << 1);
			frame[y * 4 + 1] = frame[y * 4] = (b & 2) == 0 ? 0 : content[0];
			frame[y * 4 + 3] = frame[y * 4 + 2] = (b & 1) == 0 ? 0 : content[0];
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeNeo(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 32128 || content[0] != 0 || content[1] != 0 || content[2] != 0)
		return FALSE;
	return FAIL_DecodeSt(self, content, 128, content, 4, content[3]);
}

static cibool FAIL_DecodeNlq(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[30720];
	int contentOffset;
	if (contentLength < 379 || !FAIL_IsStringAt(content, 0, "DAISY-DOT NLQ FONT") || content[18] != 155)
		return FALSE;
	FAIL_SetSize(self, 320, 96, FAILResolution_XE1X1);
	memset(frame, 0, sizeof(frame));
	contentOffset = 19;
	{
		int i;
		for (i = 0; i < 91; i++) {
			int width;
			int nextContentOffset;
			int c;
			if (contentOffset >= contentLength)
				return FALSE;
			width = content[contentOffset];
			if (width == 0 || width > 19)
				return FALSE;
			nextContentOffset = contentOffset + (width + 1) * 2;
			if (nextContentOffset > contentLength || content[nextContentOffset - 1] != 155)
				return FALSE;
			c = i < 64 ? i : i < 90 ? i + 1 : 92;
			{
				int y;
				for (y = 0; y < 16; y++) {
					{
						int x;
						for (x = 0; x < width; x++) {
							int b = (content[contentOffset + 1 + (y & 1) * width + x] >> (7 - (y >> 1))) & 1;
							frame[((c & 240) | y) * 320 + (c & 15) * 20 + x] = b == 0 ? 0 : 14;
						}
					}
				}
			}
			contentOffset = nextContentOffset;
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodePac(FAIL *self, unsigned char const *content, int contentLength)
{
	int unpackedStride;
	PacStream rle;
	unsigned char unpacked[32000];
	if (contentLength < 8 || content[0] != 112 || content[1] != 77 || content[2] != 56)
		return FALSE;
	switch (content[3]) {
	case 53:
		unpackedStride = 1;
		break;
	case 54:
		unpackedStride = 80;
		break;
	default:
		return FALSE;
	}
	PacStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 7;
	rle.base.base.contentLength = contentLength;
	if (!RleStream_Unpack(&rle.base, unpacked, 0, unpackedStride, 32000))
		return FALSE;
	return FAIL_DecodeDoo(self, unpacked, 32000);
}

static cibool FAIL_DecodePc(FAIL *self, unsigned char const *content, int contentLength)
{
	int bitplanes;
	PackBitsStream rle;
	unsigned char unpacked[32000];
	if (contentLength < 68 || content[0] != 128 || content[1] > 2)
		return FALSE;
	bitplanes = 4 >> content[1];
	PackBitsStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 34;
	rle.base.base.contentLength = contentLength;
	{
		int y;
		for (y = 0; y < 200; y++) {
			{
				int bitplane;
				for (bitplane = 0; bitplane < bitplanes; bitplane++) {
					{
						int x;
						for (x = 0; x < 40 << content[1]; x++) {
							int b = RleStream_ReadRle(&rle.base);
							if (b < 0)
								return FALSE;
							unpacked[y * 160 + (x & ~1) * bitplanes + (bitplane << 1) + (x & 1)] = b;
						}
					}
				}
			}
		}
	}
	return FAIL_DecodeSt(self, unpacked, 0, content, 2, content[1]);
}

static cibool FAIL_DecodePcs(FAIL *self, unsigned char const *content, int contentLength)
{
	PcsStream rle;
	unsigned char unpacked1[51232];
	unsigned char unpacked2[51232];
	if (contentLength < 18 || content[0] != 1 || content[1] != 64 || content[2] != 0 || content[3] != 200)
		return FALSE;
	PcsStream_Construct(&rle, NULL);
	rle.base.base.base.content = content;
	rle.base.base.base.contentOffset = 6;
	rle.base.base.base.contentLength = contentLength;
	if (!PcsStream_UnpackPcs(&rle, unpacked1))
		return FALSE;
	FAIL_SetSize(self, 320, 199, FAIL_IsStePalette(unpacked1, 32000, 9616) ? FAILResolution_STE1X1 : FAILResolution_ST1X1);
	FAIL_DecodePcsScreen(self, unpacked1, 0);
	if (content[4] == 0)
		return TRUE;
	self->frames = 2;
	rle.base.base.repeatCount = 0;
	if (!PcsStream_UnpackPcs(&rle, unpacked2))
		return FALSE;
	if ((content[4] & 1) == 0) {
		{
			int i;
			for (i = 0; i < 32000; i++)
				unpacked2[i] ^= unpacked1[i];
		}
	}
	if ((content[4] & 2) == 0) {
		{
			int i;
			for (i = 32000; i < 51232; i++)
				unpacked2[i] ^= unpacked1[i];
		}
	}
	FAIL_DecodePcsScreen(self, unpacked2, 63680);
	{
		int i;
		for (i = 0; i < 63680; i++) {
			int rgb1 = self->pixels[i];
			int rgb2 = self->pixels[63680 + i];
			self->pixels[i] = (rgb1 & rgb2) + (((rgb1 ^ rgb2) >> 1) & 8355711);
		}
	}
	return TRUE;
}

static void FAIL_DecodePcsScreen(FAIL *self, unsigned char const *unpacked, int pixelsOffset)
{
	{
		int y;
		for (y = 0; y < 199; y++) {
			{
				int x;
				for (x = 0; x < 320; x++) {
					int bitmapOffset = 40 + y * 40 + (x >> 3);
					int bit = ~x & 7;
					int c = (((unpacked[bitmapOffset] >> bit) & 1) << 1) | (((unpacked[8000 + bitmapOffset] >> bit) & 1) << 2) | (((unpacked[16000 + bitmapOffset] >> bit) & 1) << 3) | (((unpacked[24000 + bitmapOffset] >> bit) & 1) << 4);
					if (x >= c * 2) {
						if (c < 28) {
							if (x >= c * 2 + 76) {
								if (x >= 176 + c * 5 - (c & 2) * 3)
									c += 32;
								c += 32;
							}
						}
						else if (x >= c * 2 + 92)
							c += 32;
						c += 32;
					}
					self->pixels[pixelsOffset++] = FAIL_GetStColor(self, unpacked, 32000 + y * 96 + c);
				}
			}
		}
	}
}

static cibool FAIL_DecodePgc(FAIL *self, unsigned char const *content, int contentLength)
{
	PgcStream rle;
	unsigned char unpacked[1920];
	if (contentLength < 33 || content[0] != 80 || content[1] != 71 || content[2] != 1)
		return FALSE;
	PgcStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 3;
	rle.base.base.contentLength = contentLength;
	{
		int unpackedOffset;
		for (unpackedOffset = 0; unpackedOffset < 1920; unpackedOffset++) {
			int b = RleStream_ReadRle(&rle.base);
			if (b < 0) {
				if (unpackedOffset == 1919)
					b = 0;
				else
					return FALSE;
			}
			unpacked[unpackedOffset] = b;
		}
	}
	return FAIL_DecodePgf(self, unpacked, 1920);
}

static cibool FAIL_DecodePgf(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 1920)
		return FALSE;
	FAIL_DecodeBlackAndWhite(self, content, 0, 240, 64, FAILResolution_PORTFOLIO1X1);
	return TRUE;
}

static cibool FAIL_DecodePi(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength < 32034 || content[0] != 0)
		return FALSE;
	switch (contentLength) {
	case 32034:
	case 32066:
	case 32128:
		return FAIL_DecodeSt(self, content, 34, content, 2, content[1]);
	case 44834:
		if (content[1] != 0)
			return FALSE;
		return FAIL_DecodeStLow(self, content, 34, content, 2, 320, 280);
	case 116514:
		if (content[1] != 0)
			return FALSE;
		return FAIL_DecodeStLow(self, content, 34, content, 2, 416, 560);
	default:
		return FALSE;
	}
}

static cibool FAIL_DecodePi4(FAIL *self, unsigned char const *content, int contentLength)
{
	int height;
	switch (contentLength) {
	case 65024:
		height = 200;
		break;
	case 77824:
		height = 240;
		break;
	default:
		return FALSE;
	}
	FAIL_DecodeFalconPalette320(self, content, 1024, 0, height);
	return TRUE;
}

static cibool FAIL_DecodePic(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[7680];
	if (KoalaStream_UnpackKoalaWrapped(content, contentLength, unpacked, 7680)) {
		unsigned char frame[61440];
		FAIL_SetSize(self, 320, 192, FAILResolution_XE2X1);
		FAIL_SetPF0123Bak(self, content, 13);
		FAIL_DecodeAtari8Gr15(self, unpacked, 0, 40, frame, 0, 320, 192);
		return FAIL_ApplyAtari8Palette(self, frame);
	}
	if (contentLength == 7680)
		return FAIL_DecodeGr8(self, content, contentLength);
	if (contentLength >= 7681 && contentLength <= 7685)
		return FAIL_DecodeMic(self, content, contentLength);
	return FAIL_DecodeDoo(self, content, contentLength);
}

static cibool FAIL_DecodePla(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame[3840];
	if (contentLength != 241)
		return FALSE;
	FAIL_SetSize(self, 16, 240, FAILResolution_XE2X1);
	memset(frame, 0, sizeof(frame));
	FAIL_DecodeAtari8Player(self, content, 1, content[0], frame, 0, 240);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodePmd(FAIL *self, unsigned char const *content, int contentLength)
{
	int sprites;
	int shapes;
	int totalShapes;
	int height;
	int rows;
	unsigned char frame[179200];
	if (contentLength < 12 || content[0] != 240 || content[1] != 237 || content[2] != 228)
		return FALSE;
	sprites = content[7];
	shapes = content[8] * content[9];
	totalShapes = sprites * shapes;
	height = content[10];
	if (sprites == 0 || sprites > 4 || shapes == 0 || shapes > 160 || height == 0 || height > 48 || 11 + totalShapes * height != contentLength)
		return FALSE;
	if (TRUE)
		totalShapes >>= 1;
	rows = (totalShapes + 15) >> 4;
	if (rows == 1)
		FAIL_SetSize(self, totalShapes * 20, height, FAILResolution_XE2X1);
	else {
		int totalHeight = rows * height + (rows - 1) * 2;
		if (totalHeight > 560)
			return FALSE;
		FAIL_SetSize(self, 320, totalHeight, FAILResolution_XE2X1);
	}
	memset(frame, 0, sizeof(frame));
	{
		int shape;
		for (shape = 0; shape < totalShapes; shape++) {
			int frameOffset = (shape >> 4) * (height + 2) * 320 + (shape & 15) * 20;
			if (TRUE) {
				int spritePair = shape / shapes;
				int contentOffset = 11 + (spritePair * shapes + shape) * height;
				FAIL_DecodeAtari8Player(self, content, contentOffset, content[3 + spritePair * 2], frame, frameOffset, height);
				FAIL_DecodeAtari8Player(self, content, contentOffset + shapes * height, content[4 + spritePair * 2], frame, frameOffset, height);
			}
			else
				FAIL_DecodeAtari8Player(self, content, 11 + shape * height, content[3 + shape / shapes], frame, frameOffset, height);
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeRaw(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength != 15372 || !FAIL_IsStringAt(content, 0, "XLPB"))
		return FALSE;
	return FAIL_DecodeGr15Blend(self, content, 4, 15364, 192);
}

static cibool FAIL_DecodeRgb(FAIL *self, unsigned char const *content, int contentLength)
{
	int titleLength;
	int width;
	int height;
	int leftRgbs[192];
	unsigned char screens[23040];
	RgbStream rle;
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	unsigned char frame3[61440];
	if (contentLength < 9 || !FAIL_IsStringAt(content, 0, "RGB1"))
		return FALSE;
	titleLength = content[4];
	width = content[6 + titleLength];
	height = content[7 + titleLength];
	if (width == 0 || (width & 1) != 0 || width > 80 || height == 0 || height > 192 || content[8 + titleLength] != 1)
		return FALSE;
	switch (content[5 + titleLength]) {
	case 9:
		FAIL_SetSize(self, width << 2, height, FAILResolution_XE4X1);
		break;
	case 15:
		FAIL_SetSize(self, width << 2, height, FAILResolution_XE2X1);
		break;
	default:
		return FALSE;
	}
	RgbStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 9 + titleLength;
	rle.base.base.contentLength = contentLength;
	{
		int x;
		for (x = 0; x < width; x++) {
			{
				int y;
				for (y = 0; y < height; y++) {
					int rgb = RleStream_ReadRle(&rle.base);
					if (rgb < 0)
						return FALSE;
					if ((x & 1) == 0)
						leftRgbs[y] = rgb;
					else {
						int leftRgb = leftRgbs[y];
						int screenOffset = y * 40 + (x >> 1);
						screens[screenOffset] = ((leftRgb >> 4) & 240) | (rgb >> 8);
						screens[7680 + screenOffset] = (leftRgb & 240) | ((rgb >> 4) & 15);
						screens[15360 + screenOffset] = ((leftRgb << 4) & 240) | (rgb & 15);
					}
				}
			}
		}
	}
	FAIL_DecodeRgbScreen(self, screens, 0, 48, frame1);
	FAIL_DecodeRgbScreen(self, screens, 7680, 192, frame2);
	FAIL_DecodeRgbScreen(self, screens, 15360, 112, frame3);
	return FAIL_ApplyAtari8PaletteBlend3(self, frame1, frame2, frame3);
}

static void FAIL_DecodeRgbScreen(FAIL *self, unsigned char const *screens, int screensOffset, int color, unsigned char *frame)
{
	if (self->resolution == FAILResolution_XE4X1) {
		self->gtiaColors[8] = color;
		FAIL_DecodeAtari8Gr9(self, screens, screensOffset, 40, frame, 0, self->width, self->width, self->height);
	}
	else {
		self->gtiaColors[8] = 0;
		self->gtiaColors[4] = color | 4;
		self->gtiaColors[5] = color | 10;
		self->gtiaColors[6] = color | 14;
		FAIL_DecodeAtari8Gr15(self, screens, screensOffset, 40, frame, 0, self->width, self->height);
	}
}

static cibool FAIL_DecodeRip(FAIL *self, unsigned char const *content, int contentLength)
{
	int headerLength;
	int contentStride;
	int height;
	int textLength;
	int unpackedLength;
	unsigned char unpacked[20076];
	int width;
	unsigned char frame1[76480];
	unsigned char frame2[76480];
	if (contentLength < 34 || content[0] != 82 || content[1] != 73 || content[2] != 80 || content[18] != 84 || content[19] != 58)
		return FALSE;
	headerLength = content[11] | (content[12] << 8);
	contentStride = content[13];
	height = content[15];
	textLength = content[17];
	if (headerLength >= contentLength || contentStride == 0 || contentStride > 80 || (contentStride & 1) != 0 || height == 0 || height > 239 || 33 + textLength >= contentLength || content[20 + textLength] != 9 || !FAIL_IsStringAt(content, 21 + textLength, "CM:"))
		return FALSE;
	if (content[7] < 16)
		contentStride >>= 1;
	unpackedLength = contentStride * height;
	if (content[7] == 48)
		unpackedLength += (height + 1) >> 1 << 3;
	memset(unpacked, 0, sizeof(unpacked));
	switch (content[9]) {
	case 0:
		if (headerLength + unpackedLength > contentLength)
			return FALSE;
		memcpy(unpacked + 0, content + headerLength, unpackedLength);
		break;
	case 1:
		FAIL_UnpackRip(self, content, headerLength, contentLength, unpacked, unpackedLength);
		break;
	default:
		return FALSE;
	}
	FAIL_SetGtiaColors(self, content, 24 + textLength);
	contentStride = content[13] >> 1;
	width = contentStride << 3;
	switch (content[7]) {
		int colorsOffset;
	case 14:
		FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
		FAIL_DecodeAtari8Gr15(self, unpacked, 0, contentStride, frame1, 0, width, height);
		return FAIL_ApplyAtari8Palette(self, frame1);
	case 15:
		FAIL_SetSize(self, width, height, FAILResolution_XE1X1);
		FAIL_DecodeAtari8Gr8(self, unpacked, 0, frame1);
		return FAIL_ApplyAtari8Palette(self, frame1);
	case 79:
		FAIL_SetSize(self, width, height, FAILResolution_XE4X1);
		FAIL_DecodeAtari8Gr9(self, unpacked, 0, contentStride, frame1, 0, width, width, height);
		return FAIL_ApplyAtari8Palette(self, frame1);
	case 143:
		FAIL_SetSize(self, width, height, FAILResolution_XE4X1);
		self->gtiaLeftSkip = 2;
		FAIL_DecodeAtari8Gr10(self, unpacked, 0, frame1, 0, width, height);
		return FAIL_ApplyAtari8Palette(self, frame1);
	case 207:
		FAIL_SetSize(self, width, height, FAILResolution_XE4X1);
		FAIL_DecodeAtari8Gr11(self, content, 0, frame1, 0, width, height);
		return FAIL_ApplyAtari8Palette(self, frame1);
	case 30:
		FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
		FAIL_DecodeAtari8Gr15(self, unpacked, 0, contentStride, frame1, 0, width, height);
		FAIL_DecodeAtari8Gr15(self, unpacked, height * contentStride, contentStride, frame2, 0, width, height);
		return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
	case 16:
		FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
		FAIL_SetBakPF012(self, content, 28 + textLength, 1);
		FAIL_DecodeAtari8Gr15(self, unpacked, 0, contentStride << 1, frame1, 0, width << 1, height >> 1);
		FAIL_SetBakPF012(self, content, 24 + textLength, 1);
		FAIL_DecodeAtari8Gr15(self, unpacked, contentStride, contentStride << 1, frame1, width, width << 1, height >> 1);
		FAIL_DecodeAtari8Gr15(self, unpacked, height * contentStride, contentStride << 1, frame2, 0, width << 1, height >> 1);
		FAIL_SetBakPF012(self, content, 28 + textLength, 1);
		FAIL_DecodeAtari8Gr15(self, unpacked, (height + 1) * contentStride, contentStride << 1, frame2, width, width << 1, height >> 1);
		return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
	case 32:
		FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
		self->gtiaLeftSkip = 1;
		FAIL_DecodeAtari8Gr10(self, unpacked, 0, frame1, 0, width, height);
		self->gtiaColors[8] = 0;
		FAIL_DecodeAtari8Gr9(self, unpacked, height * contentStride, contentStride, frame2, 0, width, width, height);
		return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
	case 48:
		FAIL_SetSize(self, width, height, FAILResolution_XE2X1);
		self->gtiaLeftSkip = 1;
		self->gtiaColors[0] = 0;
		colorsOffset = height * contentStride << 1;
		{
			int y;
			for (y = 0; y < height; y += 2) {
				FAIL_SetPM123PF0123Bak(self, unpacked, colorsOffset + (y << 2));
				FAIL_DecodeAtari8Gr10(self, unpacked, y * contentStride, frame1, y * width, width, y + 1 < height ? 2 : 1);
			}
		}
		self->gtiaColors[8] = 0;
		FAIL_DecodeAtari8Gr9(self, unpacked, height * contentStride, contentStride, frame2, 0, width, width, height);
		return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
	default:
		return FALSE;
	}
}

static cibool FAIL_DecodeRm(FAIL *self, unsigned char const *content, int contentLength, int mode, FAILResolution resolution)
{
	unsigned char unpacked[7680];
	int colorsOffset;
	int dliOffset;
	cibool dliPresent[192];
	int height;
	unsigned char frame[61440];
	if (KoalaStream_UnpackKoalaWrapped(content, contentLength - 464, unpacked, mode == 0 ? 3840 : 7680)) {
		colorsOffset = contentLength - 464;
		dliOffset = contentLength - 384;
	}
	else if (contentLength == 8192) {
		memcpy(unpacked + 0, content + 0, 7680);
		colorsOffset = 7680;
		dliOffset = 7808;
	}
	else
		return FALSE;
	memset(dliPresent, 0, sizeof(dliPresent));
	{
		int i;
		for (i = 0; i < 128; i++) {
			int y = content[dliOffset + i];
			switch (y) {
			case 0:
				break;
			case 1:
			case 2:
			case 4:
			case 5:
				return FALSE;
			default:
				if (mode == 0) {
					if (y >= 101)
						return FALSE;
					if (y == 3)
						y = 0;
					else
						y -= 5;
				}
				else {
					if (y == 100 || y == 101 || y >= 198)
						return FALSE;
					if (y == 3)
						y = 1;
					else if (y < 100)
						y -= 4;
					else
						y -= 6;
				}
				dliPresent[y] = TRUE;
				break;
			}
		}
	}
	FAIL_SetSize(self, 320, 192, resolution);
	if (mode == 2)
		self->gtiaLeftSkip = 2;
	if (mode == 1)
		self->gtiaColors[8] = content[colorsOffset + 8] & 240;
	else
		FAIL_SetGtiaColors(self, content, colorsOffset);
	height = mode == 0 ? 96 : 192;
	{
		int y;
		for (y = 0; y < height; y++) {
			switch (mode) {
			case 0:
				FAIL_DecodeAtari8Gr7(self, unpacked, y * 40, frame, y * 640, 1);
				break;
			case 1:
				FAIL_DecodeAtari8Gr9(self, unpacked, y * 40, 40, frame, y * 320, 320, 320, 1);
				break;
			case 2:
				FAIL_DecodeAtari8Gr10(self, unpacked, y * 40, frame, y * 320, 320, 1);
				break;
			case 3:
				FAIL_DecodeAtari8Gr11(self, unpacked, y * 40, frame, y * 320, 320, 1);
				break;
			case 4:
				FAIL_DecodeAtari8Gr15(self, unpacked, y * 40, 40, frame, y * 320, 320, 1);
				break;
			}
			if (dliPresent[y]) {
				int vcount = mode == 0 ? 16 + y : 16 + ((y - 1) >> 1);
				int reg = content[dliOffset + 128 + vcount];
				if (reg < 9)
					FAIL_SetGtiaColor(self, reg, content[dliOffset + 256 + vcount]);
				else if (reg != 128)
					return FALSE;
			}
		}
	}
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeSge(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char font[1024];
	unsigned char frame[61440];
	if (contentLength != 960)
		return FALSE;
	memcpy(font + 0, CiBinaryResource_atari8_fnt + 0, 1024);
	{
		int i;
		for (i = 0; i < 4; i++) {
			font[1004 + i] = font[728 + i] = 15;
			font[1000 + i] = font[732 + i] = 240;
		}
	}
	FAIL_SetSize(self, 320, 192, FAILResolution_XE1X1);
	FAIL_DecodeAtari8Gr0(self, content, 40, font, 0, frame);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeShc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[61440];
	unsigned char frame2[61440];
	int col1;
	int col2;
	if (contentLength != 17920)
		return FALSE;
	FAIL_SetSize(self, 320, 192, FAILResolution_XE1X1);
	col1 = 15360;
	col2 = 16640;
	{
		int y;
		for (y = 0; y < 192; y++) {
			{
				int x;
				for (x = 0; x < 320; x++) {
					int i = 320 * y + x;
					int bit = ~x & 7;
					switch (x) {
					case 94:
					case 166:
					case 214:
					case 262:
					case 306:
						col1++;
						break;
					case 46:
					case 142:
					case 190:
					case 238:
					case 286:
						col2++;
						break;
					default:
						break;
					}
					frame1[i] = content[col1] & (((content[i >> 3] >> bit) & 1) != 0 ? 240 : 254);
					frame2[i] = content[col2] & (((content[7680 + (i >> 3)] >> bit) & 1) != 0 ? 240 : 254);
				}
			}
			col1++;
			col2++;
		}
	}
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeShp(FAIL *self, unsigned char const *content, int contentLength)
{
	switch (contentLength) {
	case 1024:
		return FAIL_DecodeBlazingPaddlesVectors(self, content, contentLength, 31744);
	case 4384:
		return FAIL_DecodeGr7(self, content, 528, 3844);
	default:
		return FALSE;
	}
}

static cibool FAIL_DecodeSps(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[51104];
	SpsStream rle;
	BitStream bitStream;
	if (contentLength < 13 || content[0] != 83 || content[1] != 80 || content[2] != 0 || content[3] != 0)
		return FALSE;
	SpsStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 12;
	rle.base.base.contentLength = contentLength;
	if ((content[contentLength - 1] & 1) == 0) {
		{
			int bitplane;
			for (bitplane = 0; bitplane < 8; bitplane += 2) {
				{
					int x;
					for (x = 0; x < 40; x++) {
						{
							int unpackedOffset;
							for (unpackedOffset = 160 + ((x & ~1) << 2) + bitplane + (x & 1); unpackedOffset < 32000; unpackedOffset += 160) {
								int b = RleStream_ReadRle(&rle.base);
								if (b < 0)
									return FALSE;
								unpacked[unpackedOffset] = b;
							}
						}
					}
				}
			}
		}
	}
	else {
		if (!FAIL_UnpackSpc(&rle.base, unpacked))
			return FALSE;
	}
	BitStream_Construct(&bitStream);
	bitStream.content = content;
	bitStream.contentOffset = 12 + FAIL_Get32BigEndian(content, 4);
	bitStream.contentLength = contentLength;
	{
		int unpackedOffset;
		for (unpackedOffset = 32000; unpackedOffset < 51104;) {
			int got = BitStream_ReadBits(&bitStream, 14);
			if (got < 0)
				return FALSE;
			got <<= 1;
			{
				int i;
				for (i = 15; i >= 0; i--) {
					int rgb;
					if (((got >> i) & 1) == 0)
						rgb = 0;
					else {
						rgb = BitStream_ReadBits(&bitStream, 9);
						if (rgb < 0)
							return FALSE;
					}
					unpacked[unpackedOffset] = rgb >> 6;
					unpacked[unpackedOffset + 1] = (rgb & 63) + (rgb & 56);
					unpackedOffset += 2;
				}
			}
		}
	}
	return FAIL_DecodeSpu(self, unpacked, 51104);
}

static cibool FAIL_DecodeSpu(FAIL *self, unsigned char const *content, int contentLength)
{
	int pixelsOffset;
	if (contentLength != 51104)
		return FALSE;
	FAIL_SetSize(self, 320, 199, FAIL_IsStePalette(content, 32000, 9552) ? FAILResolution_STE1X1 : FAILResolution_ST1X1);
	pixelsOffset = 0;
	{
		int y;
		for (y = 0; y < 199; y++) {
			{
				int x;
				for (x = 0; x < 320; x++) {
					int bitmapOffset = 160 + ((pixelsOffset >> 1) & ~7) + ((x >> 3) & 1);
					int bit = ~x & 7;
					int c = (((content[bitmapOffset] >> bit) & 1) << 1) | (((content[bitmapOffset + 2] >> bit) & 1) << 2) | (((content[bitmapOffset + 4] >> bit) & 1) << 3) | (((content[bitmapOffset + 6] >> bit) & 1) << 4);
					int x1 = c * 5 + 1 - (c & 2) * 3;
					if (x >= x1 + 160)
						c += 64;
					else if (x >= x1)
						c += 32;
					self->pixels[pixelsOffset++] = FAIL_GetStColor(self, content, 32000 + y * 96 + c);
				}
			}
		}
	}
	return TRUE;
}

static cibool FAIL_DecodeSt(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset, int mode)
{
	switch (mode) {
	case 0:
		return FAIL_DecodeStLow(self, bitmap, bitmapOffset, palette, paletteOffset, 320, 200);
	case 1:
		FAIL_DecodeStMedium(self, bitmap, bitmapOffset, palette, paletteOffset);
		return TRUE;
	case 2:
		FAIL_DecodeBlackAndWhite(self, bitmap, bitmapOffset, 640, 400, FAILResolution_ST1X1);
		return TRUE;
	default:
		return FALSE;
	}
}

static cibool FAIL_DecodeStIcn(FAIL *self, unsigned char const *content, int contentLength)
{
	IcnParser parser;
	int width;
	int height;
	int size;
	unsigned char bitmap[44800];
	parser.content = content;
	parser.contentOffset = 0;
	parser.contentLength = contentLength;
	width = IcnParser_ParseDefine(&parser, "ICON_W");
	if (width <= 0 || width >= 640)
		return FALSE;
	height = IcnParser_ParseDefine(&parser, "ICON_H");
	if (height <= 0 || height >= 560)
		return FALSE;
	size = IcnParser_ParseDefine(&parser, "ICONSIZE");
	if (size != ((width + 15) >> 4) * height)
		return FALSE;
	if (!IcnParser_Expect(&parser, "int") || !IcnParser_Expect(&parser, "image[ICONSIZE]") || !IcnParser_Expect(&parser, "=") || !IcnParser_Expect(&parser, "{"))
		return FALSE;
	{
		int i;
		for (i = 0;;) {
			int value = IcnParser_ParseHex(&parser);
			if (value < 0)
				return FALSE;
			bitmap[i * 2] = value >> 8;
			bitmap[i * 2 + 1] = (unsigned char) value;
			if (++i >= size)
				break;
			if (parser.contentOffset >= contentLength || content[parser.contentOffset++] != 44)
				return FALSE;
		}
	}
	if (!IcnParser_Expect(&parser, "};"))
		return FALSE;
	FAIL_DecodeBlackAndWhite(self, bitmap, 0, (width + 15) & ~15, height, FAILResolution_ST1X1);
	return TRUE;
}

static cibool FAIL_DecodeStLow(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset, int width, int height)
{
	FAIL_SetSize(self, width, height, FAIL_IsStePalette(palette, paletteOffset, 16) ? FAILResolution_STE1X1 : FAILResolution_ST1X1);
	FAIL_SetStPalette(self, palette, paletteOffset, 16);
	FAIL_DecodeBitplanes(self, bitmap, bitmapOffset, 4, 0, width * height);
	return TRUE;
}

static void FAIL_DecodeStMedium(FAIL *self, unsigned char const *bitmap, int bitmapOffset, unsigned char const *palette, int paletteOffset)
{
	FAIL_SetSize(self, 640, 400, FAIL_IsStePalette(palette, paletteOffset, 4) ? FAILResolution_STE1X2 : FAILResolution_ST1X2);
	FAIL_SetStPalette(self, palette, paletteOffset, 4);
	{
		int y;
		for (y = 0; y < 200; y++) {
			{
				int x;
				for (x = 0; x < 640; x++) {
					int offset = bitmapOffset + y * 160 + ((x >> 2) & ~3) + ((x >> 3) & 1);
					int bit = ~x & 7;
					int c = ((bitmap[offset] >> bit) & 1) | (((bitmap[offset + 2] >> bit) & 1) << 1);
					int pixelsOffset = y * 1280 + x;
					self->pixels[pixelsOffset + 640] = self->pixels[pixelsOffset] = self->atari16Palette[c];
				}
			}
		}
	}
}

static cibool FAIL_DecodeStSpc(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char unpacked[51104];
	SpcStream rle;
	int contentOffset;
	if (contentLength < 12 || content[0] != 83 || content[1] != 80)
		return FALSE;
	SpcStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = 12;
	rle.base.base.contentLength = contentLength;
	if (!FAIL_UnpackSpc(&rle.base, unpacked))
		return FALSE;
	contentOffset = 12 + FAIL_Get32BigEndian(content, 4);
	{
		int unpackedOffset;
		for (unpackedOffset = 32000; unpackedOffset < 51104;) {
			int got;
			if (contentOffset + 1 >= contentLength)
				return FALSE;
			got = (content[contentOffset] << 8) | content[contentOffset + 1];
			contentOffset += 2;
			{
				int i;
				for (i = 0; i < 16; i++) {
					if (((got >> i) & 1) == 0) {
						unpacked[unpackedOffset] = 0;
						unpacked[unpackedOffset + 1] = 0;
					}
					else {
						if (contentOffset + 1 >= contentLength)
							return FALSE;
						unpacked[unpackedOffset] = content[contentOffset];
						unpacked[unpackedOffset + 1] = content[contentOffset + 1];
						contentOffset += 2;
					}
					unpackedOffset += 2;
				}
			}
		}
	}
	return FAIL_DecodeSpu(self, unpacked, 51104);
}

static cibool FAIL_DecodeSxs(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char characters[128];
	if (contentLength != 1030 || FAIL_ParseAtari8ExecutableHeader(content, 0) != 1024)
		return FALSE;
	{
		int i;
		for (i = 0; i < 128; i++)
			characters[i] = (i & 65) | ((i >> 4) & 2) | ((i & 30) << 1);
	}
	return FAIL_DecodeAtari8Font(self, characters, content, 6);
}

static cibool FAIL_DecodeTip(FAIL *self, unsigned char const *content, int contentLength)
{
	int width;
	int height;
	int contentStride;
	int frameLength;
	static const unsigned char colors[9] = { 0, 2, 4, 6, 8, 10, 12, 14, 0 };
	unsigned char frame1[76160];
	unsigned char frame2[76160];
	if (contentLength < 129 || content[0] != 84 || content[1] != 73 || content[2] != 80 || content[3] != 1 || content[4] != 0)
		return FALSE;
	width = content[5];
	height = content[6];
	if (width > 160 || (width & 3) != 0 || height > 119)
		return FALSE;
	contentStride = width >> 2;
	frameLength = content[7] | (content[8] << 8);
	if (frameLength != contentStride * height || contentLength != 9 + 3 * frameLength)
		return FALSE;
	FAIL_SetSize(self, width << 1, height << 1, FAILResolution_XE2X2);
	self->gtiaLeftSkip = 1;
	FAIL_SetGtiaColors(self, colors, 0);
	FAIL_DecodeAtari8Gr9(self, content, 9, contentStride, frame1, width << 1, width << 2, width << 1, height);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 9 + 2 * frameLength, contentStride, frame1, 0);
	FAIL_DecodeAtari8Gr10(self, content, 9 + frameLength, frame2, width << 1, width << 2, height);
	FAIL_DecodeAtari8Gr11PalBlend(self, content, 9 + 2 * frameLength, contentStride, frame2, 0);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeTny(FAIL *self, unsigned char const *content, int contentLength)
{
	int mode;
	int contentOffset;
	int controlLength;
	int valueLength;
	TnyStream rle;
	unsigned char unpacked[32000];
	if (contentLength < 42)
		return FALSE;
	mode = content[0];
	if (mode > 2) {
		if (mode > 5)
			return FALSE;
		mode -= 3;
		contentOffset = 4;
	}
	else
		contentOffset = 0;
	controlLength = (content[contentOffset + 33] << 8) | content[contentOffset + 34];
	valueLength = ((content[contentOffset + 35] << 8) | content[contentOffset + 36]) << 1;
	if (contentOffset + 37 + controlLength + valueLength > contentLength)
		return FALSE;
	TnyStream_Construct(&rle, NULL);
	rle.base.base.base.content = content;
	rle.base.base.base.contentOffset = contentOffset + 37;
	rle.valueOffset = rle.base.base.base.contentLength = contentOffset + 37 + controlLength;
	rle.valueLength = contentOffset + 37 + controlLength + valueLength;
	{
		int bitplane;
		for (bitplane = 0; bitplane < 8; bitplane += 2) {
			{
				int x;
				for (x = bitplane; x < 160; x += 8) {
					{
						int unpackedOffset;
						for (unpackedOffset = x; unpackedOffset < 32000; unpackedOffset += 160) {
							int b = RleStream_ReadRle(&rle.base.base);
							if (b < 0)
								return FALSE;
							unpacked[unpackedOffset] = b >> 8;
							unpacked[unpackedOffset + 1] = (unsigned char) b;
						}
					}
				}
			}
		}
	}
	return FAIL_DecodeSt(self, unpacked, 0, content, contentOffset + 1, mode);
}

static cibool FAIL_DecodeTrp(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength < 9 || !FAIL_IsStringAt(content, 0, "TRUP"))
		return FALSE;
	return FAIL_DecodeFalconTrueColorVariable(self, content, contentLength, 4, 8);
}

static cibool FAIL_DecodeTru(FAIL *self, unsigned char const *content, int contentLength)
{
	if (contentLength < 256 || !FAIL_IsStringAt(content, 0, "Indy"))
		return FALSE;
	return FAIL_DecodeFalconTrueColorVariable(self, content, contentLength, 4, 256);
}

static cibool FAIL_DecodeVzi(FAIL *self, unsigned char const *content, int contentLength)
{
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	if (contentLength != 16000)
		return FALSE;
	FAIL_SetSize(self, 320, 200, FAILResolution_XE2X1);
	self->gtiaLeftSkip = -1;
	FAIL_DecodeAtari8Gr9(self, content, 0, 40, frame1, 0, 320, 320, 200);
	self->gtiaLeftSkip = 1;
	FAIL_DecodeAtari8Gr9(self, content, 8000, 40, frame2, 0, 320, 320, 200);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DecodeWnd(FAIL *self, unsigned char const *content, int contentLength)
{
	int contentStride;
	int height;
	unsigned char frame[61440];
	if (contentLength != 3072)
		return FALSE;
	contentStride = (content[0] >> 2) + 1;
	height = content[1];
	if (contentStride > 40 || height == 0 || height > 192 || contentStride * height > 3070)
		return FALSE;
	FAIL_SetSize(self, contentStride << 3, height, FAILResolution_XE2X1);
	self->gtiaColors[8] = 0;
	self->gtiaColors[4] = 70;
	self->gtiaColors[5] = 136;
	self->gtiaColors[6] = 14;
	FAIL_DecodeAtari8Gr15(self, content, 2, contentStride, frame, 0, contentStride << 3, height);
	return FAIL_ApplyAtari8Palette(self, frame);
}

static cibool FAIL_DecodeXlp(FAIL *self, unsigned char const *content, int contentLength)
{
	XlpStream rle;
	unsigned char unpacked[16000];
	int height;
	int colorsOffset;
	unsigned char frame1[64000];
	unsigned char frame2[64000];
	XlpStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentLength = contentLength;
	if (contentLength >= 10 && FAIL_IsStringAt(content, 0, "XLPC")) {
		memset(unpacked, 0, sizeof(unpacked));
		rle.base.base.contentOffset = 8;
		RleStream_Unpack(&rle.base, unpacked, 0, 40, 15360);
		height = 192;
		colorsOffset = 4;
	}
	else {
		rle.base.base.contentOffset = 4;
		if (RleStream_Unpack(&rle.base, unpacked, 0, 40, 16000))
			height = 200;
		else {
			rle.base.base.contentOffset = 4;
			if (RleStream_Unpack(&rle.base, unpacked, 0, 40, 15360))
				height = 192;
			else
				return FALSE;
		}
		colorsOffset = 0;
	}
	FAIL_SetSize(self, 320, height, FAILResolution_XE2X1);
	FAIL_SetPF012Bak(self, content, colorsOffset);
	FAIL_DecodeAtari8Gr15(self, unpacked, 0, 40, frame1, 0, 320, height);
	FAIL_DecodeAtari8Gr15(self, unpacked, height * 40, 40, frame2, 0, 320, height);
	return FAIL_ApplyAtari8PaletteBlend(self, frame1, frame2);
}

static cibool FAIL_DrawBlazingPaddlesVector(FAIL const *self, unsigned char const *content, int contentLength, unsigned char *frame, int frameOffset, int index, int startAddress)
{
	int contentOffset;
	if (index * 2 + 1 >= contentLength)
		return FALSE;
	contentOffset = content[index * 2] + (content[index * 2 + 1] << 8) - startAddress;
	if (contentOffset < 0)
		return FALSE;
	while (contentOffset < contentLength) {
		int control = content[contentOffset++];
		if (control == 8)
			return TRUE;
		for (; control >= 0; control -= 16) {
			if ((control & 4) == 0)
				frame[frameOffset + 1] = frame[frameOffset] = 14;
			switch (control & 3) {
			case 0:
				frameOffset += 2;
				break;
			case 1:
				frameOffset -= 2;
				break;
			case 2:
				frameOffset -= self->width;
				break;
			case 3:
				frameOffset += self->width;
				break;
			}
		}
	}
	return FALSE;
}

static void FAIL_DrawSpcBrush(unsigned char *pixels, int x1, int y1, int brush, int pattern)
{
	static const unsigned char brushes[128] = { 0, 0, 0, 0, 0, 0, 16, 16, 0, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 0, 48, 48, 48, 48, 0, 0, 0, 0, 0, 0, 0,
		0, 0, 0, 0, 16, 56, 56, 56, 56, 16, 0, 0, 0, 0, 0, 0,
		0, 0, 16, 56, 56, 124, 124, 124, 124, 56, 56, 16, 0, 0, 0, 0,
		0, 24, 24, 60, 60, 126, 126, 126, 126, 60, 60, 24, 24, 0, 0, 0,
		16, 56, 124, 124, 124, 254, 254, 254, 254, 124, 124, 124, 56, 16, 0, 0,
		0, 0, 16, 40, 40, 80, 60, 120, 20, 40, 40, 16, 0, 0, 0, 0,
		16, 40, 84, 40, 84, 186, 124, 124, 186, 84, 40, 84, 40, 16, 0, 0 };
	{
		int y;
		for (y = 0; y < 16 && y1 + y < 192; y++) {
			int brushShape = brushes[brush * 16 + y];
			{
				int x;
				for (x = 0; x < 8 && x1 + x < 160; x++) {
					if (((brushShape >> (7 - x)) & 1) != 0)
						FAIL_PlotSpcPattern(pixels, x, y, pattern);
				}
			}
		}
	}
}

static void FAIL_DrawSpcChar(unsigned char *pixels, int x1, int y1, int ch)
{
	unsigned char const *font;
	int fontOffset;
	if (ch < 32 || ch > 95)
		return;
	font = CiBinaryResource_atari8_fnt;
	fontOffset = (ch - 32) << 3;
	{
		int y;
		for (y = 0; y < 8 && y1 + y < 192; y++) {
			{
				int x;
				for (x = 0; x < 4 && x1 + x < 160; x++)
					pixels[(y1 + y) * 160 + x1 + x] = (font[fontOffset + y] >> (6 - x * 2)) & 3;
			}
		}
	}
}

static void FAIL_DrawSpcLine(unsigned char *pixels, int x1, int y1, int x2, int y2, int color)
{
	int dx = x2 - x1;
	int dy = y2 - y1;
	if (dx < 0)
		dx = -dx;
	if (dy < 0)
		dy = -dy;
	if (dx >= dy) {
		int e = dx;
		if (x2 < x1) {
			int ty = y1;
			x1 = x2;
			x2 += dx;
			y1 = y2;
			y2 = ty;
		}
		for (; x1 <= x2; x1++) {
			if (x1 < 160 && y1 < 192)
				pixels[160 * y1 + x1] = color;
			e -= dy * 2;
			if (e < 0) {
				e += dx * 2;
				y1 += y1 < y2 ? 1 : -1;
			}
		}
	}
	else {
		int e = dy;
		if (y2 < y1) {
			int tx = x1;
			x1 = x2;
			x2 = tx;
			y1 = y2;
			y2 += dy;
		}
		for (; y1 <= y2; y1++) {
			if (x1 < 160 && y1 < 192)
				pixels[160 * y1 + x1] = color;
			e -= dx * 2;
			if (e < 0) {
				e += dy * 2;
				x1 += x1 < x2 ? 1 : -1;
			}
		}
	}
}

static cibool FAIL_FillSpc(unsigned char *pixels, int x, int y, int pattern)
{
	if (x >= 160 || y >= 192)
		return FALSE;
	while (y >= 0 && pixels[y * 160 + x] == 0)
		y--;
	while (++y < 192 && pixels[y * 160 + x] == 0) {
		int x1;
		do
			x--;
		while (x >= 0 && pixels[y * 160 + x] == 0);
		x1 = x;
		while (x < 159 && pixels[y * 160 + ++x] == 0)
			FAIL_PlotSpcPattern(pixels, x, y, pattern);
		x = x1 + ((x - x1 + 1) >> 1);
	}
	return TRUE;
}

static int FAIL_FindColor(int const *palette, int paletteEnd, int rgb)
{
	int paletteBegin = 0;
	while (paletteBegin < paletteEnd) {
		int index = (paletteBegin + paletteEnd) >> 1;
		int paletteRgb = palette[index];
		if (rgb == paletteRgb)
			return index;
		if (rgb < paletteRgb)
			paletteEnd = index;
		else
			paletteBegin = index + 1;
	}
	return paletteBegin;
}

static int FAIL_Get32BigEndian(unsigned char const *content, int contentOffset)
{
	return (content[contentOffset] << 24) | (content[contentOffset + 1] << 16) | (content[contentOffset + 2] << 8) | content[contentOffset + 3];
}

static int FAIL_GetAtari8ExecutableOffset(unsigned char const *content, int contentLength)
{
	if (contentLength >= 7) {
		int blockLength = FAIL_ParseAtari8ExecutableHeader(content, 0);
		if (blockLength > 0 && 6 + blockLength == contentLength)
			return 6;
	}
	return 0;
}

int FAIL_GetColors(FAIL *self)
{
	if (self->colors == -1) {
		memset(self->palette, 0, sizeof(self->palette));
		FAIL_CalculatePalette(self, self->palette, 0, 256);
	}
	if (self->colors == 0) {
		int *palette = (int *) malloc(self->width * self->height * sizeof(int ));
		{
			int j;
			for (j = 0; j < 256; j++)
				palette[j] = self->palette[j];
		}
		FAIL_CalculatePalette(self, palette, 256, -1);
		free(palette);
	}
	return self->colors;
}

int FAIL_GetFrames(FAIL const *self)
{
	return self->frames;
}

int FAIL_GetHeight(FAIL const *self)
{
	return self->height;
}

int FAIL_GetOriginalHeight(FAIL const *self)
{
	switch (self->resolution) {
	case FAILResolution_XE2X2:
	case FAILResolution_XE4X2:
	case FAILResolution_ST1X2:
	case FAILResolution_STE1X2:
		return self->height >> 1;
	default:
		return self->height;
	}
}

int FAIL_GetOriginalWidth(FAIL const *self)
{
	switch (self->resolution) {
	case FAILResolution_XE2X1:
	case FAILResolution_XE2X2:
		return self->width >> 1;
	case FAILResolution_XE4X1:
	case FAILResolution_XE4X2:
		return self->width >> 2;
	default:
		return self->width;
	}
}

static int FAIL_GetPackedExt(const char *filename)
{
	int ext = 0;
	{
		int i;
		for (i = (int) strlen(filename); --i > 0;) {
			int c = filename[i];
			if (c <= 32 || c > 122)
				return 0;
			if (c == 46)
				return ext | 2105376;
			ext = (ext << 8) + c;
		}
	}
	return 0;
}

int const *FAIL_GetPixels(FAIL const *self)
{
	return self->pixels;
}

const char *FAIL_GetPlatform(FAIL const *self)
{
	switch (self->resolution) {
	case FAILResolution_XE1X1:
	case FAILResolution_XE2X1:
	case FAILResolution_XE4X1:
	case FAILResolution_XE2X2:
	case FAILResolution_XE4X2:
		return "Atari 8-bit";
	case FAILResolution_ST1X1:
	case FAILResolution_ST1X2:
		return "Atari ST";
	case FAILResolution_STE1X1:
	case FAILResolution_STE1X2:
		return "Atari STE";
	case FAILResolution_FALCON1X1:
		return "Atari Falcon";
	case FAILResolution_PORTFOLIO1X1:
		return "Atari Portfolio";
	case FAILResolution_AMIGA1X1:
		return "Amiga";
	default:
		return NULL;
	}
}

static int FAIL_GetStColor(FAIL const *self, unsigned char const *content, int contentOffset)
{
	int r = content[contentOffset];
	int gb = content[contentOffset + 1];
	int rgb;
	switch (self->resolution) {
	case FAILResolution_STE1X1:
	case FAILResolution_STE1X2:
		rgb = ((r & 7) << 17) | ((r & 8) << 13) | ((gb & 112) << 5) | ((gb & 135) << 1) | ((gb & 8) >> 3);
		return (rgb << 4) | rgb;
	default:
		rgb = ((r & 7) << 16) | ((gb & 112) << 4) | (gb & 7);
		return (rgb << 5) | (rgb << 2) | ((rgb >> 1) & 197379);
	}
}

int FAIL_GetWidth(FAIL const *self)
{
	return self->width;
}

cibool FAIL_IsOurFile(const char *filename)
{
	switch (FAIL_GetPackedExt(filename)) {
	case 3552562:
	case 6909236:
	case 7106612:
	case 7172148:
	case 7484513:
	case 7562081:
	case 7366497:
	case 7105633:
	case 3305569:
	case 3371105:
	case 7762017:
	case 7366500:
	case 6517605:
	case 6515817:
	case 7174768:
	case 6516833:
	case 7106657:
	case 7368801:
	case 7631457:
	case 3762018:
	case 3747943:
	case 6777698:
	case 7696994:
	case 3236195:
	case 3301731:
	case 3367267:
	case 6906723:
	case 7497827:
	case 7235939:
	case 7499875:
	case 7630947:
	case 3236708:
	case 7103844:
	case 3237732:
	case 6514532:
	case 7694180:
	case 7235940:
	case 7171172:
	case 7303012:
	case 6844516:
	case 6779492:
	case 7630438:
	case 6517862:
	case 6387558:
	case 6776935:
	case 6582119:
	case 3158375:
	case 3223911:
	case 6448743:
	case 3633767:
	case 3699303:
	case 3764839:
	case 7367016:
	case 7172200:
	case 2126440:
	case 3306088:
	case 6710889:
	case 3239010:
	case 3304546:
	case 3370082:
	case 7234409:
	case 6645609:
	case 7236969:
	case 6778473:
	case 7368297:
	case 7630441:
	case 3305577:
	case 6516841:
	case 3306089:
	case 6779497:
	case 7631721:
	case 7366506:
	case 7889261:
	case 6775405:
	case 6841197:
	case 7365485:
	case 7562093:
	case 7366509:
	case 6515053:
	case 7563629:
	case 7300462:
	case 7433326:
	case 6513008:
	case 3236720:
	case 3302256:
	case 3367792:
	case 7562096:
	case 6514544:
	case 6711152:
	case 3238256:
	case 3303792:
	case 3369328:
	case 3434864:
	case 3762544:
	case 6515056:
	case 6384752:
	case 7171184:
	case 6581616:
	case 7823730:
	case 6449010:
	case 7367026:
	case 3173746:
	case 3239282:
	case 3304818:
	case 3370354:
	case 3435890:
	case 6645619:
	case 6514803:
	case 7366771:
	case 6516851:
	case 7565427:
	case 7696499:
	case 7567475:
	case 7367028:
	case 3239540:
	case 3305076:
	case 3370612:
	case 7958132:
	case 7369332:
	case 7697012:
	case 6912630:
	case 6581879:
	case 7367800:
		return TRUE;
	default:
		return FALSE;
	}
}

static cibool FAIL_IsStePalette(unsigned char const *content, int contentOffset, int colors)
{
	while (--colors >= 0) {
		if ((content[contentOffset] & 8) != 0 || (content[contentOffset + 1] & 136) != 0)
			return TRUE;
		contentOffset += 2;
	}
	return FALSE;
}

static cibool FAIL_IsStringAt(unsigned char const *content, int contentOffset, const char *s)
{
	int length = (int) strlen(s);
	{
		int i;
		for (i = 0; i < length; i++)
			if (content[contentOffset + i] != s[i])
				return FALSE;
	}
	return TRUE;
}

static int FAIL_ParseAtari8ExecutableHeader(unsigned char const *content, int contentOffset)
{
	int startAddress;
	int endAddress;
	if (content[contentOffset] != 255 || content[contentOffset + 1] != 255)
		return -1;
	startAddress = content[contentOffset + 2] | (content[contentOffset + 3] << 8);
	endAddress = content[contentOffset + 4] | (content[contentOffset + 5] << 8);
	return endAddress - startAddress + 1;
}

static void FAIL_PlotSpcPattern(unsigned char *pixels, int x, int y, int pattern)
{
	pixels[y * 160 + x] = (pattern >> ((~y & 1) * 8 + (~x & 3) * 2)) & 3;
}

void FAIL_SetAtari8Palette(FAIL *self, unsigned char const *content)
{
	if (content == NULL)
		content = CiBinaryResource_jakub_act;
	{
		int i;
		for (i = 0; i < 256; i++)
			self->atari8Palette[i] = (content[i * 3] << 16) | (content[i * 3 + 1] << 8) | content[i * 3 + 2];
	}
}

static cibool FAIL_SetAtari8RawSize(FAIL *self, unsigned char const *content, int contentLength, FAILResolution resolution)
{
	int contentOffset = FAIL_GetAtari8ExecutableOffset(content, contentLength);
	int height = (contentLength - contentOffset) / 40;
	if (height == 0 || height > 240)
		return FALSE;
	FAIL_SetSize(self, 320, height, resolution);
	return TRUE;
}

static void FAIL_SetBakPF012(FAIL *self, unsigned char const *content, int contentOffset, int contentStride)
{
	{
		int i;
		for (i = 0; i < 4; i++)
			self->gtiaColors[i == 0 ? 8 : 3 + i] = content[contentOffset + i * contentStride] & 254;
	}
}

static void FAIL_SetBakPF0123(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 5; i++)
			self->gtiaColors[i == 0 ? 8 : 3 + i] = content[contentOffset + i] & 254;
	}
}

static void FAIL_SetFalconPalette(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 256; i++) {
			int offset = contentOffset + (i << 2);
			self->atari16Palette[i] = (content[offset] << 16) | (content[offset + 1] << 8) | content[offset + 3];
		}
	}
}

static void FAIL_SetGr15DefaultColors(FAIL *self)
{
	self->gtiaColors[8] = 0;
	self->gtiaColors[4] = 4;
	self->gtiaColors[5] = 8;
	self->gtiaColors[6] = 12;
}

static void FAIL_SetGtiaColor(FAIL *self, int reg, int value)
{
	value &= 254;
	switch (reg) {
	case 0:
	case 1:
	case 2:
	case 3:
		self->gtiaColors[reg] = value;
		break;
	case 4:
	case 5:
	case 6:
	case 7:
		self->gtiaColors[8 + reg] = self->gtiaColors[reg] = value;
		break;
	case 8:
		self->gtiaColors[11] = self->gtiaColors[10] = self->gtiaColors[9] = self->gtiaColors[8] = value;
		break;
	}
}

static void FAIL_SetGtiaColors(FAIL *self, unsigned char const *content, int contentOffset)
{
	self->gtiaColors[0] = content[contentOffset] & 254;
	FAIL_SetPM123PF0123Bak(self, content, contentOffset + 1);
}

static void FAIL_SetPF0123Bak(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 5; i++)
			self->gtiaColors[4 + i] = content[contentOffset + i] & 254;
	}
}

static void FAIL_SetPF0123Even(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 4; i++)
			self->gtiaColors[4 + i] = content[contentOffset + i * 2] & 254;
	}
}

static void FAIL_SetPF012Bak(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 4; i++)
			self->gtiaColors[i == 3 ? 8 : 4 + i] = content[contentOffset + i] & 254;
	}
}

static void FAIL_SetPF21(FAIL *self, unsigned char const *content, int contentOffset)
{
	self->gtiaColors[6] = content[contentOffset] & 254;
	self->gtiaColors[5] = content[contentOffset + 1] & 254;
}

static void FAIL_SetPM123PF0123Bak(FAIL *self, unsigned char const *content, int contentOffset)
{
	{
		int i;
		for (i = 0; i < 8; i++)
			FAIL_SetGtiaColor(self, 1 + i, content[contentOffset + i]);
	}
}

static void FAIL_SetSize(FAIL *self, int width, int height, FAILResolution resolution)
{
	self->width = width;
	self->height = height;
	self->resolution = resolution;
	self->frames = 1;
	self->colors = -1;
	self->gtiaLeftSkip = 0;
}

static void FAIL_SetSizeStOrFalcon(FAIL *self, int width, int height, int bitplanes)
{
	FAIL_SetSize(self, width, height, (bitplanes == 1 && width <= 640 && height <= 400) || (bitplanes <= 4 && width <= 320 && height <= 200) ? FAILResolution_ST1X1 : FAILResolution_FALCON1X1);
}

static void FAIL_SetStPalette(FAIL *self, unsigned char const *content, int contentOffset, int colors)
{
	{
		int c;
		for (c = 0; c < colors; c++)
			self->atari16Palette[c] = FAIL_GetStColor(self, content, contentOffset + c * 2);
	}
}

static int FAIL_ToAtari8Char(int ascii)
{
	switch (ascii & 96) {
	case 0:
		return ascii + 64;
	case 32:
	case 64:
		return ascii - 32;
	default:
		return ascii;
	}
}

int const *FAIL_ToPalette(FAIL *self, unsigned char *indexes)
{
	int pixelsCount;
	if (self->colors == -1) {
		memset(self->palette, 0, sizeof(self->palette));
		FAIL_CalculatePalette(self, self->palette, 0, 256);
	}
	if (self->colors == 0 || self->colors > 256)
		return NULL;
	pixelsCount = self->width * self->height;
	{
		int i;
		for (i = 0; i < pixelsCount; i++)
			indexes[i] = FAIL_FindColor(self->palette, self->colors, self->pixels[i]);
	}
	return self->palette;
}

static cibool FAIL_UnpackRip(FAIL const *self, unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedLength)
{
	FanoTree lengthTree;
	FanoTree distanceTree;
	FanoTree literalTree;
	BitStream bitStream;
	if (contentOffset + 304 > contentLength || !FAIL_IsStringAt(content, contentOffset, "PCK"))
		return FALSE;
	FanoTree_Create(&lengthTree, content, contentOffset + 16, 64);
	FanoTree_Create(&distanceTree, content, contentOffset + 16 + 32, 256);
	FanoTree_Create(&literalTree, content, contentOffset + 16 + 32 + 128, 256);
	BitStream_Construct(&bitStream);
	bitStream.content = content;
	bitStream.contentOffset = contentOffset + 16 + 288;
	bitStream.contentLength = contentLength;
	{
		int unpackedOffset;
		for (unpackedOffset = 0; unpackedOffset < unpackedLength;) {
			switch (BitStream_ReadBit(&bitStream)) {
				int literal;
				int distance;
				int length;
			case -1:
				return FALSE;
			case 0:
				literal = FanoTree_ReadCode(&literalTree, &bitStream);
				if (literal < 0)
					return FALSE;
				unpacked[unpackedOffset++] = literal;
				break;
			case 1:
				distance = FanoTree_ReadCode(&distanceTree, &bitStream);
				if (distance < 0)
					return FALSE;
				distance += 2;
				if (distance > unpackedOffset)
					return FALSE;
				length = FanoTree_ReadCode(&lengthTree, &bitStream);
				if (length < 0)
					return FALSE;
				length += 2;
				do {
					unpacked[unpackedOffset] = unpacked[unpackedOffset - distance];
					if (++unpackedOffset >= unpackedLength)
						return TRUE;
				}
				while (--length > 0);
				break;
			}
		}
	}
	return TRUE;
}

static cibool FAIL_UnpackSpc(RleStream *rle, unsigned char *unpacked)
{
	{
		int bitplane;
		for (bitplane = 0; bitplane < 8; bitplane += 2) {
			{
				int unpackedOffset;
				for (unpackedOffset = 160 + bitplane; unpackedOffset < 32000; unpackedOffset += 8) {
					{
						int x;
						for (x = 0; x < 2; x++) {
							int b = RleStream_ReadRle(rle);
							if (b < 0)
								return FALSE;
							unpacked[unpackedOffset + x] = b;
						}
					}
				}
			}
		}
	}
	return TRUE;
}

static void FanoTree_Create(FanoTree *self, unsigned char const *content, int contentOffset, int codeCount)
{
	int positions[16];
	int position;
	memset(self->count, 0, sizeof(self->count));
	{
		int code;
		for (code = 0; code < codeCount; code++) {
			int bits = content[contentOffset + (code >> 1)];
			bits = (code & 1) == 0 ? bits >> 4 : bits & 15;
			self->count[bits]++;
		}
	}
	position = 0;
	{
		int bits;
		for (bits = 0; bits < 16; bits++) {
			positions[bits] = position;
			position += self->count[bits];
		}
	}
	{
		int code;
		for (code = 0; code < codeCount; code++) {
			int bits = content[contentOffset + (code >> 1)];
			bits = (code & 1) == 0 ? bits >> 4 : bits & 15;
			self->values[positions[bits]++] = code;
		}
	}
}

static int FanoTree_ReadCode(FanoTree const *self, BitStream *bitStream)
{
	int code = 0;
	int valuesOffset = self->count[0];
	{
		int bits;
		for (bits = 1; bits < 16; bits++) {
			int bit = BitStream_ReadBit(bitStream);
			int count;
			if (bit < 0)
				return -1;
			code = (code << 1) | bit;
			count = self->count[bits];
			if (code < count)
				return self->values[valuesOffset + code];
			code -= count;
			valuesOffset += count;
		}
	}
	return -1;
}

static void HpmStream_Construct(HpmStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_HpmStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool HpmStream_ReadCommand(HpmStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b == 0) {
		self->base.repeatValue = RleStream_ReadByte(&self->base);
		self->base.repeatCount = RleStream_ReadByte(&self->base);
	}
	else {
		self->base.repeatCount = b;
		self->base.repeatValue = -1;
	}
	return TRUE;
}

static cibool IcnParser_Expect(IcnParser *self, const char *s)
{
	int length;
	if (!IcnParser_SkipWhitespace(self))
		return FALSE;
	length = (int) strlen(s);
	{
		int i;
		for (i = 0; i < length; i++)
			if (self->content[self->contentOffset++] != s[i])
				return FALSE;
	}
	return TRUE;
}

static int IcnParser_ParseDefine(IcnParser *self, const char *s)
{
	if (!IcnParser_Expect(self, "#define") || !IcnParser_Expect(self, s))
		return -1;
	return IcnParser_ParseHex(self);
}

static int IcnParser_ParseHex(IcnParser *self)
{
	int r;
	if (!IcnParser_Expect(self, "0x"))
		return -1;
	r = 0;
	for (; self->contentOffset < self->contentLength; self->contentOffset++) {
		int c = self->content[self->contentOffset];
		if (c >= 48 && c <= 57)
			c -= 48;
		else if (c >= 65 && c <= 70)
			c -= 55;
		else if (c >= 97 && c <= 102)
			c -= 87;
		else
			return r;
		if (r >> 12 != 0)
			return -1;
		r = (r << 4) | c;
	}
	return r;
}

static cibool IcnParser_SkipWhitespace(IcnParser *self)
{
	cibool got = FALSE;
	while (self->contentOffset < self->contentLength) {
		switch (self->content[self->contentOffset]) {
		case 32:
		case 9:
		case 13:
		case 10:
			self->contentOffset++;
			got = TRUE;
			break;
		case 47:
			if (self->contentOffset + 3 >= self->contentLength || self->content[self->contentOffset + 1] != 42)
				return FALSE;
			self->contentOffset += 3;
			do {
				if (++self->contentOffset > self->contentLength)
					return FALSE;
			}
			while (self->content[self->contentOffset - 2] != 42 || self->content[self->contentOffset - 1] != 47);
			got = TRUE;
			break;
		default:
			return got;
		}
	}
	return TRUE;
}

static void KoalaStream_Construct(KoalaStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_KoalaStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool KoalaStream_ReadCommand(KoalaStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	cibool rle;
	if (b < 0)
		return FALSE;
	if (b < 128)
		rle = TRUE;
	else {
		b -= 128;
		rle = FALSE;
	}
	if (b == 0) {
		int hi = RleStream_ReadByte(&self->base);
		if (hi < 0)
			return FALSE;
		b = RleStream_ReadByte(&self->base);
		if (b < 0)
			return FALSE;
		b |= hi << 8;
	}
	self->base.repeatCount = b;
	self->base.repeatValue = rle ? RleStream_ReadByte(&self->base) : -1;
	return TRUE;
}

static cibool KoalaStream_UnpackKoala(int type, unsigned char const *content, int contentOffset, int contentLength, unsigned char *unpacked, int unpackedLength)
{
	KoalaStream rle;
	KoalaStream_Construct(&rle, NULL);
	rle.base.base.content = content;
	rle.base.base.contentOffset = contentOffset;
	rle.base.base.contentLength = contentLength;
	switch (type) {
	case 0:
		if (contentLength - contentOffset != unpackedLength)
			return FALSE;
		memcpy(unpacked + 0, content + contentOffset, unpackedLength);
		return TRUE;
	case 1:
		{
			int x;
			for (x = 0; x < 40; x++) {
				{
					int offset;
					for (offset = x; offset < 80; offset += 40) {
						{
							int unpackedOffset;
							for (unpackedOffset = offset; unpackedOffset < unpackedLength; unpackedOffset += 80) {
								int b = RleStream_ReadRle(&rle.base);
								if (b < 0)
									return FALSE;
								unpacked[unpackedOffset] = b;
							}
						}
					}
				}
			}
		}
		return TRUE;
	case 2:
		return RleStream_Unpack(&rle.base, unpacked, 0, 1, unpackedLength);
	default:
		return FALSE;
	}
}

static cibool KoalaStream_UnpackKoalaWrapped(unsigned char const *content, int contentLength, unsigned char *unpacked, int unpackedLength)
{
	return contentLength >= 26 && content[0] == 255 && content[1] == 128 && content[2] == 201 && content[3] == 199 && content[4] >= 26 && content[4] < contentLength && content[5] == 0 && content[6] == 1 && content[8] == 14 && content[9] == 0 && content[10] == 40 && content[11] == 0 && content[12] == 192 && content[20] == 0 && content[21] == 0 && KoalaStream_UnpackKoala(content[7], content, content[4] + 1, contentLength, unpacked, unpackedLength);
}

static void PacStream_Construct(PacStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_PacStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool PacStream_ReadCommand(PacStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b == self->base.base.content[4]) {
		b = RleStream_ReadByte(&self->base);
		if (b < 0)
			return FALSE;
		self->base.repeatCount = b + 1;
		self->base.repeatValue = self->base.base.content[5];
	}
	else if (b == self->base.base.content[6]) {
		self->base.repeatValue = RleStream_ReadByte(&self->base);
		if (self->base.repeatValue < 0)
			return FALSE;
		b = RleStream_ReadByte(&self->base);
		if (b < 0)
			return FALSE;
		self->base.repeatCount = b + 1;
	}
	else {
		self->base.repeatCount = 1;
		self->base.repeatValue = b;
	}
	return TRUE;
}

static void PackBitsStream_Construct(PackBitsStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_PackBitsStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool PackBitsStream_ReadCommand(PackBitsStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		self->base.repeatCount = b + 1;
		self->base.repeatValue = -1;
	}
	else if (b > 128) {
		self->base.repeatCount = 257 - b;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
	}
	else
		self->base.repeatCount = 0;
	return TRUE;
}

static void PcsStream_Construct(PcsStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_PcsStream;
	TnyPcsStream_Construct(&self->base, vtbl);
}

static int PcsStream_ReadValue(PcsStream *self)
{
	int value;
	if (!self->palette)
		return RleStream_ReadByte(&self->base.base);
	if (self->base.base.base.contentOffset + 1 >= self->base.base.base.contentLength)
		return -1;
	value = (self->base.base.base.content[self->base.base.base.contentOffset] << 8) | self->base.base.base.content[self->base.base.base.contentOffset + 1];
	self->base.base.base.contentOffset += 2;
	return value;
}

static cibool PcsStream_UnpackPcs(PcsStream *self, unsigned char *unpacked)
{
	self->base.base.base.contentOffset += 2;
	self->palette = FALSE;
	{
		int unpackedOffset;
		for (unpackedOffset = 0; unpackedOffset < 32000; unpackedOffset++) {
			int b = RleStream_ReadRle(&self->base.base);
			if (b < 0)
				return FALSE;
			unpacked[unpackedOffset] = b;
		}
	}
	if (self->base.base.repeatCount != 0)
		return FALSE;
	self->base.base.base.contentOffset += 2;
	self->palette = TRUE;
	{
		int unpackedOffset;
		for (unpackedOffset = 32000; unpackedOffset < 51232; unpackedOffset += 2) {
			int b = RleStream_ReadRle(&self->base.base);
			if (b < 0)
				return FALSE;
			unpacked[unpackedOffset] = b >> 8;
			unpacked[unpackedOffset + 1] = (unsigned char) b;
		}
	}
	return TRUE;
}

static void PgcStream_Construct(PgcStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_PgcStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool PgcStream_ReadCommand(PgcStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		self->base.repeatCount = b;
		self->base.repeatValue = -1;
	}
	else {
		self->base.repeatCount = b - 128;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
	}
	return TRUE;
}

static void RgbStream_Construct(RgbStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_RgbStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool RgbStream_ReadCommand(RgbStream *self)
{
	int b = BitStream_ReadBits(&self->base.base, 4);
	cibool rle;
	if (b < 0)
		return FALSE;
	if (b < 8)
		rle = TRUE;
	else {
		b -= 8;
		rle = FALSE;
	}
	if (b == 0) {
		b = BitStream_ReadBits(&self->base.base, 4);
		if (b < 0)
			return FALSE;
		b += 7;
	}
	if (rle) {
		self->base.repeatValue = self->base.vtbl->readValue(&self->base);
		b++;
	}
	else
		self->base.repeatValue = -1;
	self->base.repeatCount = b;
	return TRUE;
}

static int RgbStream_ReadValue(RgbStream *self)
{
	return BitStream_ReadBits(&self->base.base, 12);
}

static void RleStream_Construct(RleStream *self, const RleStreamVtbl *vtbl)
{
	self->vtbl = vtbl;
	BitStream_Construct(&self->base);
	self->repeatCount = 0;
}

static int RleStream_ReadByte(RleStream *self)
{
	if (self->base.contentOffset >= self->base.contentLength)
		return -1;
	return self->base.content[self->base.contentOffset++];
}

static int RleStream_ReadRle(RleStream *self)
{
	while (self->repeatCount == 0) {
		if (!self->vtbl->readCommand(self))
			return -1;
	}
	self->repeatCount--;
	if (self->repeatValue >= 0)
		return self->repeatValue;
	return self->vtbl->readValue(self);
}

static int RleStream_ReadValue(RleStream *self)
{
	return RleStream_ReadByte(self);
}

static cibool RleStream_Unpack(RleStream *self, unsigned char *unpacked, int unpackedOffset, int unpackedStride, int unpackedCount)
{
	{
		int offset;
		for (offset = 0;;) {
			int b = RleStream_ReadRle(self);
			if (b < 0)
				return FALSE;
			unpacked[unpackedOffset + offset] = b;
			offset += unpackedStride;
			if (offset >= unpackedCount) {
				if (unpackedStride > 1)
					offset -= unpackedCount - 1;
				if (offset >= unpackedStride)
					return TRUE;
			}
		}
	}
}

static void SpcStream_Construct(SpcStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_SpcStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool SpcStream_ReadCommand(SpcStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		self->base.repeatCount = b + 1;
		self->base.repeatValue = -1;
	}
	else {
		self->base.repeatCount = 258 - b;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
	}
	return TRUE;
}

static void SpsStream_Construct(SpsStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_SpsStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool SpsStream_ReadCommand(SpsStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		self->base.repeatCount = b + 3;
		self->base.repeatValue = RleStream_ReadByte(&self->base);
	}
	else {
		self->base.repeatCount = b - 127;
		self->base.repeatValue = -1;
	}
	return TRUE;
}

static void TnyPcsStream_Construct(TnyPcsStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_TnyPcsStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool TnyPcsStream_ReadCommand(TnyPcsStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		if (b == 0 || b == 1) {
			if (self->base.base.contentOffset + 1 >= self->base.base.contentLength)
				return FALSE;
			self->base.repeatCount = (self->base.base.content[self->base.base.contentOffset] << 8) | self->base.base.content[self->base.base.contentOffset + 1];
			self->base.base.contentOffset += 2;
		}
		else
			self->base.repeatCount = b;
		self->base.repeatValue = b == 1 ? -1 : (&self->base)->vtbl->readValue(&self->base);
	}
	else {
		self->base.repeatCount = 256 - b;
		self->base.repeatValue = -1;
	}
	return TRUE;
}

static void TnyStream_Construct(TnyStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_TnyStream;
	TnyPcsStream_Construct(&self->base, vtbl);
}

static int TnyStream_ReadValue(TnyStream *self)
{
	int value;
	if (self->valueOffset + 1 >= self->valueLength)
		return -1;
	value = (self->base.base.base.content[self->valueOffset] << 8) | self->base.base.base.content[self->valueOffset + 1];
	self->valueOffset += 2;
	return value;
}

static void VdatStream_Construct(VdatStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_VdatStream;
	TnyStream_Construct(&self->base, vtbl);
}

static cibool VdatStream_ReadCommand(VdatStream *self)
{
	int b = RleStream_ReadByte(&self->base.base.base);
	if (b < 0)
		return FALSE;
	if (b < 128) {
		if (b == 0 || b == 1) {
			self->base.base.base.repeatCount = (&self->base)->base.base.vtbl->readValue(&(&self->base)->base.base);
			if (self->base.base.base.repeatCount < 0)
				return FALSE;
		}
		else
			self->base.base.base.repeatCount = b;
		self->base.base.base.repeatValue = b == 0 ? -1 : (&self->base)->base.base.vtbl->readValue(&(&self->base)->base.base);
	}
	else {
		self->base.base.base.repeatCount = 256 - b;
		self->base.base.base.repeatValue = -1;
	}
	return TRUE;
}

static void XlpStream_Construct(XlpStream *self, const RleStreamVtbl *vtbl)
{
	if (vtbl == NULL)
		vtbl = &CiVtbl_XlpStream;
	RleStream_Construct(&self->base, vtbl);
}

static cibool XlpStream_ReadCommand(XlpStream *self)
{
	int b = RleStream_ReadByte(&self->base);
	cibool rle;
	if (b < 0)
		return FALSE;
	if (b < 128)
		rle = FALSE;
	else {
		b -= 128;
		rle = TRUE;
	}
	self->base.repeatCount = b;
	if (b >= 64) {
		b = RleStream_ReadByte(&self->base);
		if (b < 0)
			return FALSE;
		self->base.repeatCount = ((self->base.repeatCount - 64) << 8) | b;
	}
	self->base.repeatValue = rle ? RleStream_ReadByte(&self->base) : -1;
	return TRUE;
}
